/*
 * Created on Oct 22, 2005
 */
package proxyconfig;

import javax.swing.*;

/**
 * @author danjo
 */
abstract public class WizardDialog extends JDialog {
    
    public WizardDialog(ProxyConfig proxyConfig, String wizardTitle) {
        super(proxyConfig, wizardTitle, true);
               
    }
    
    /** Did the user OK the changes made using the wizard? 
     * @return true if yes.
     */
    abstract public boolean isOK();
    
    /** Did the user make any changes to the configuration
     * using the wizard
     * @return true if yes.
     */
    abstract public boolean hasChanged();
    
    /** Update the OCD from the onscreen data */
    abstract public void update();
    
    /** Check if the fields of the wizard have been filled up in some sane manner. */
    abstract public boolean checkFields();

}
