/*
 * Created on May 18, 2005
 */
package proxyconfig.certificate;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import proxyconfig.ProxyConfig;


/**
 * @author danjo
 */
public class CertificateConfirmPanel extends JPanel {

    JTextField nameTF;
    JTextField realNameTF;
    
    JTextField emailTF;
    JTextField passwordTF;
    
    public CertificateConfirmPanel() {

        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        setLayout (new BoxLayout (this, BoxLayout.Y_AXIS));
        
        JPanel mainPanel = new JPanel();
        mainPanel.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        add (mainPanel);
        
    	//Construct the GUI
		Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		mainPanel.setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		JLabel tempLabel;

		// The preferred Dimension of all the input fields - mainly used to enforce a common height
		Dimension minDim = new Dimension(50, 25);
		
		tempLabel = new JLabel("Requested Name");
		tempLabel.setBackground(Color.WHITE);
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);

		nameTF = new JTextField(20);
		nameTF.setMinimumSize(minDim);
		nameTF.setEditable(false);
		nameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(nameTF, gc);
		mainPanel.add(nameTF);

		tempLabel = new JLabel("Real Name");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		//gbag.setConstraints(tempLabel, gc);
		//mainPanel.add(tempLabel);
	    
		realNameTF = new JTextField(20);
		realNameTF.setMinimumSize(minDim);
		realNameTF.setEditable(false);
		realNameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		//gbag.setConstraints(realNameTF, gc);
		//mainPanel.add(realNameTF);

		tempLabel = new JLabel("Email Address");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);
	    
		emailTF = new JTextField(20);
		emailTF.setMinimumSize(minDim);
		emailTF.setEditable (false);
		emailTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 1.0;
		gbag.setConstraints(emailTF, gc);
		mainPanel.add(emailTF);

		tempLabel = new JLabel("Confirmation Password");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 3;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);
	    
		passwordTF = new JTextField(20);
		passwordTF.setMinimumSize(minDim);
		passwordTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 3;
		gc.weightx = 1.0;
		gbag.setConstraints(passwordTF, gc);
		mainPanel.add(passwordTF);
		

        passwordTF.requestFocus();
    }

    public void setFocus () {
        passwordTF.requestFocus();
    }
    
    public Dimension getPreferredSize() {
        
        return new Dimension(500,300);
    }
    
    boolean checkFields() {
        
        if (passwordTF.getText().trim().equals ("")) {
            JOptionPane.showMessageDialog (null, "Password field must not be empty.", "Incomplete", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        return true;
    }

}
