/*
 * Created on Apr 22, 2006
 */
package proxyconfig.i3;

import javax.swing.*;

import proxyconfig.*;
import proxyconfig.mynames.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * @author danjo
 */
public class ExistingNameCheckDialog extends JDialog implements ActionListener {

    private JComboBox nameCB;
    
    boolean createNewFlag = false;
    
    ExistingNameCheckDialog (ProxyConfig proxyConfig, ArrayList existingNamesList) {
        super (proxyConfig, "Existing names found", true);
     	int xInsets = 300;
    	int yInsets = 250;
    	
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
    	
    	//Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    	Dimension screenSize = new Dimension(1024,768);
    	
    	setResizable(false);
    	
    	setBounds(xInsets, yInsets, screenSize.width - xInsets*2, screenSize.height - yInsets * 2);
        
        Container contents = getContentPane();
        
        contents.setLayout(new BoxLayout(contents, BoxLayout.Y_AXIS));
        contents.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        contents.add (Box.createVerticalGlue());
        
        JPanel tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        contents.add(tmpPanel);
        
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));

        JEditorPane tmpLabel = new JEditorPane("text/html",
                 	"This machine already has name(s) set for it.  What would you like to do?");
        tmpLabel.setEditable(false);
        tmpLabel.setBackground (ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.add( (Box.createHorizontalGlue()));
        tmpPanel.add(tmpLabel);
        tmpLabel.setMaximumSize(new Dimension(200,50));
        tmpPanel.add( (Box.createHorizontalGlue()));
            
        contents.add(Box.createRigidArea(new Dimension(20,20)));
        
        tmpPanel = new JPanel();
        tmpPanel.setLayout (new BoxLayout (tmpPanel, BoxLayout.X_AXIS));
        contents.add (tmpPanel);
        JButton editNameBT = new JButton ("Edit the details of the existing name shown below");
        editNameBT.setActionCommand ("EDIT");
        editNameBT.addActionListener (this);
        tmpPanel.add (Box.createHorizontalGlue());
        tmpPanel.add (editNameBT);
        tmpPanel.add (Box.createHorizontalGlue());


        tmpPanel = new JPanel();
        tmpPanel.setLayout (new BoxLayout (tmpPanel, BoxLayout.X_AXIS));
        contents.add (tmpPanel);
        nameCB = new JComboBox();
        nameCB.setEditable(false);
        nameCB.setBackground(Color.WHITE);
        nameCB.setMaximumSize (new Dimension (500,30));
        Iterator itr = existingNamesList.iterator();
        while (itr.hasNext()) {
            nameCB.addItem((MyName)itr.next());
        }
        tmpPanel.add (Box.createHorizontalGlue());
        tmpPanel.add (nameCB);
        tmpPanel.add (Box.createHorizontalGlue());

        
        contents.add (Box.createRigidArea (new Dimension (25,25)));
        
        tmpPanel = new JPanel();
        tmpPanel.setLayout (new BoxLayout (tmpPanel, BoxLayout.X_AXIS));
        contents.add(tmpPanel);
        tmpLabel = new JEditorPane("text/html",
     				"<center>OR</center>");
        tmpLabel.setEditable(false);
        tmpLabel.setBackground (ProxyConfig.BACKGROUND_COLOR);
        tmpLabel.setMaximumSize(new Dimension(200,50));
        tmpPanel.add( (Box.createHorizontalGlue()));
        tmpPanel.add(tmpLabel);        
        tmpPanel.add( (Box.createHorizontalGlue()));

        contents.add (Box.createRigidArea (new Dimension (25,25)));
        
        tmpPanel = new JPanel();
        tmpPanel.setLayout (new BoxLayout (tmpPanel, BoxLayout.X_AXIS));
        contents.add (tmpPanel);
        tmpPanel.add (Box.createHorizontalGlue());
        JButton newBT = new JButton ("Create a NEW name");
        newBT.setActionCommand("NEW");
        newBT.addActionListener (this);
        tmpPanel.add (newBT);
        tmpPanel.add (Box.createHorizontalGlue());
        
        
        contents.add (Box.createVerticalGlue());
    }
    
    public void actionPerformed (ActionEvent ae) {
        
        String cmdStr = ae.getActionCommand();
        
        if (cmdStr.equals ("EDIT")) {
            createNewFlag = false;
        } else {
            createNewFlag = true;
        }
        
        setVisible (false);
    }
    
    MyName getSelectedName() {
        
        return (MyName) nameCB.getSelectedItem();
    }
}
