/*
 * Created on Jan 21, 2005
 */
package proxyconfig.i3;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.*;

import proxyconfig.HelpButton;
import proxyconfig.InputChangeListener;
import proxyconfig.ProxyConfig;
import proxyconfig.ocd.OCD;

import java.awt.*;
import java.awt.event.*;

/**
 * @author danjo
 */
public class I3OCDPanel extends JPanel implements ActionListener {

    ProxyConfig proxyConfig;
    I3OCD overlay;

    JTextField descriptionTF;
    JTextField idTF;
    
    JTextField localPortNumTF;
    JCheckBox shortcutCheckBox;
    JCheckBox fastConnectionCheckBox;
    
    InputChangeListener changeListener;
    
    public I3OCDPanel (OCD overlay, ProxyConfig proxyConfig, InputChangeListener changeListener) {
        this.overlay = (I3OCD) overlay;
        this.changeListener = changeListener;
        this.proxyConfig = proxyConfig;

        changeListener.setEnabled(false);
        setBackground( proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        /*
        add(new MessageLabel(
                "Configure overlay network with id " + overlay.id, 
                ProxyConfig.HEADING_COLOR, 	//background color
                20 //font size
                ));
        
        add(Box.createRigidArea(new Dimension(10,10)));
        
        */

        add(Box.createVerticalGlue());

        
        JPanel tmpPanel;


            Dimension minDim = new Dimension (50,20);
        
        JPanel mainPanel = new JPanel();
        mainPanel.setMaximumSize(new Dimension(500,100));
        mainPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        add(mainPanel);
        
        Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		mainPanel.setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

        JLabel tempLB;

        
        tempLB = new JLabel ("Overlay Identifier (eg: pli3)");
        
        gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLB, gc);
		mainPanel.add (tempLB);

        idTF = new JTextField (10);
        idTF.setMinimumSize (minDim);
        idTF.getDocument().addDocumentListener(changeListener);
        
        gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(idTF, gc);
		mainPanel.add (idTF);

		if (overlay.id != null) {
		    idTF.setText(overlay.id);
		} else {
		    idTF.setText ("");
		}
		
        tempLB = new JLabel ("Description");
        
        gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLB, gc);
		mainPanel.add (tempLB);

        descriptionTF = new JTextField (25);
        descriptionTF.setMinimumSize (minDim);
        descriptionTF.getDocument().addDocumentListener(changeListener);
        
        gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(descriptionTF, gc);
		mainPanel.add (descriptionTF);
		
		if (overlay.description != null) {
		    descriptionTF.setText(overlay.description);
		} else {
		    descriptionTF.setText("");
		}

        tempLB = new JLabel ("Local Port Number");
        
        gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLB, gc);
		mainPanel.add (tempLB);

        localPortNumTF = new JTextField (10);
        localPortNumTF.setMinimumSize (minDim);
        
        gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(localPortNumTF, gc);
		mainPanel.add (localPortNumTF);
		
		localPortNumTF.setText ("" + this.overlay.localPortNum);
		localPortNumTF.getDocument().addDocumentListener(changeListener);
        
		tempLB = new JLabel ("Enable Shortcut");
        gc.gridx = 0;
		gc.gridy = 3;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLB, gc);
		mainPanel.add (tempLB);

        shortcutCheckBox = new JCheckBox();
        shortcutCheckBox.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        gc.gridx = 1;
		gc.gridy = 3;
		gc.weightx = 0.0;
		gbag.setConstraints(shortcutCheckBox, gc);
		mainPanel.add (shortcutCheckBox);
		
		if (this.overlay.enableShortcut) {
		    shortcutCheckBox.setSelected (true);
		}
		shortcutCheckBox.addChangeListener(changeListener);
		
		tempLB = new JLabel ("Enable FastConnetion");
        gc.gridx = 0;
		gc.gridy = 4;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLB, gc);
		mainPanel.add (tempLB);

        fastConnectionCheckBox = new JCheckBox();
        fastConnectionCheckBox.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        gc.gridx = 1;
		gc.gridy = 4;
		gc.weightx = 0.0;
		gbag.setConstraints(fastConnectionCheckBox, gc);
		mainPanel.add (fastConnectionCheckBox);
        
		if (this.overlay.enableFastConnection) {
		    fastConnectionCheckBox.setSelected(true);
		}
		fastConnectionCheckBox.addChangeListener (changeListener);
		
        add(Box.createVerticalGlue());
        
        changeListener.setEnabled(true);
    }
    
    public void actionPerformed(ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        if (cmd.equals("HELP_URL_SUFFIX")) {
            JOptionPane.showMessageDialog(null,
                  "URLs with the suffixes specified here are handled by this overlay by default." +
                  "\nSeparate multiple suffixes by spaces.",
                  "HELP: URL Suffixes",
                  JOptionPane.INFORMATION_MESSAGE
            	);
        }
    }
    
    public void update() {
        
        overlay.id = idTF.getText();
        overlay.description = descriptionTF.getText();
        
        if (overlay.addressBookFileName == null) {
            overlay.addressBookFileName = overlay.id + "_address_book.txt";
        }
        overlay.propertyMap.remove (I3OCD.ADDRESS_BOOK_FILENAME);
        overlay.propertyMap.put (I3OCD.ADDRESS_BOOK_FILENAME, overlay.addressBookFileName);
        
        if (overlay.configFile == null) {
            overlay.configFile = "i3-cfg-" + overlay.id + ".xml";
        }
        
        overlay.enableShortcut = shortcutCheckBox.isSelected();
        overlay.propertyMap.remove(I3OCD.ENABLE_SHORTCUT);
        if (overlay.enableShortcut) {
            overlay.propertyMap.put (I3OCD.ENABLE_SHORTCUT, "yes");
        } else {
            overlay.propertyMap.put (I3OCD.ENABLE_SHORTCUT, "no");
        }
        
        overlay.enableFastConnection = fastConnectionCheckBox.isSelected();
        overlay.propertyMap.remove(I3OCD.ENABLE_FAST_CONNECTION);
        if (overlay.enableFastConnection) {
            overlay.propertyMap.put (I3OCD.ENABLE_FAST_CONNECTION, "yes");
        } else {
            overlay.propertyMap.put (I3OCD.ENABLE_FAST_CONNECTION, "no");
        }
        
        try {
            overlay.localPortNum = Integer.parseInt (localPortNumTF.getText());
        } catch (NumberFormatException nfe) {
            System.out.println ("Invalid i3 local port number = " + localPortNumTF.getText() + "\n");
        }
        overlay.propertyMap.remove (I3OCD.LOCAL_PORT_NUMBER);
        overlay.propertyMap.put (I3OCD.LOCAL_PORT_NUMBER, "" + overlay.localPortNum);
        
    }
    
    public boolean checkFields() {
        
        String tmpId = idTF.getText();
        
        boolean retVal = true;
        String msg ="";
        if (tmpId.trim().equals("")) {
            msg += "The overlay id field must not be blank.\n";
            retVal = false;
        }
        
        OCD checkOCD = proxyConfig.proxyConfigData.getOverlayById(tmpId);
        if (checkOCD != null && checkOCD != overlay) {
            msg += "An overlay with the specified id already exists.\n" +
            "Please choose another id.\n";
            retVal = false;
        }
        
        if (!retVal) {
            JOptionPane.showMessageDialog (proxyConfig,
                    msg, "Error",
                    JOptionPane.ERROR_MESSAGE
                   );
        }
        
        return retVal;
    }
}
