/*
 * Created on Jan 21, 2005
 */
package proxyconfig.i3;

import javax.swing.*;

import proxyconfig.HelpButton;
import proxyconfig.InputChangeListener;
import proxyconfig.ProxyConfig;

import java.awt.*;
import java.util.*;
import java.awt.event.*;

/**
 * @author danjo
 */
public class I3ServerPanel extends JPanel implements ActionListener {

    InputChangeListener changeListener;
    
    JEditorPane tcpLB;
    
    JTextField statusTF;
    
    I3OCD overlay;
    
    JComboBox knownServerCombo;
    
    I3ServerPanel (I3OCD overlay, InputChangeListener changeListener) {
        this.overlay = overlay;
        this.changeListener = changeListener;
        
        changeListener.setEnabled(false);
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        JPanel tmpPanel;

        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);

        JEditorPane headingLB = new JEditorPane();
        tmpPanel.add(headingLB);
        headingLB.setContentType("text/html");
        headingLB.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        headingLB.setText("<h2 color=\"blue\"><font face=\"arial\">I3 Servers</h2>");
        headingLB.setMaximumSize(new Dimension(400,50));
        
        tmpPanel.add(Box.createHorizontalGlue());

        
        add(Box.createVerticalGlue());
        
        
        JPanel serverPanel = new JPanel();
        serverPanel.setMaximumSize(new Dimension(500,100));
        serverPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        add(serverPanel);
        
        Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		serverPanel.setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		
		JLabel tempLabel;

		
		tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        tcpLB = new JEditorPane();
        tcpLB.setContentType("text/html");
        tcpLB.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tcpLB.setText("<font face=\"arial\">Contact I3 Servers using");
        
        tcpLB.setEditable(false);
        tcpLB.setMaximumSize(new Dimension(400,60));
        tmpPanel.add(tcpLB);
        tmpPanel.add(new HelpButton("HELP_PROTOCOL", this));
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tmpPanel, gc);
		serverPanel.add(tmpPanel);


		tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));

        ButtonGroup protocolBTGrp = new ButtonGroup();
        
        JRadioButton tcpBT = new JRadioButton("TCP");
        tcpBT.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tcpBT.addChangeListener(changeListener);
        protocolBTGrp.add(tcpBT);
        tcpBT.setActionCommand("TCP");
        tcpBT.addActionListener(this);
        tmpPanel.add(tcpBT);
        
        JRadioButton udpBT = new JRadioButton("UDP");
        udpBT.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        udpBT.addChangeListener(changeListener);
        protocolBTGrp.add(udpBT);
        udpBT.setActionCommand("UDP");
        udpBT.addActionListener(this);
        tmpPanel.add(udpBT);
        
        if (this.overlay.i3UseTCP) {
            tcpBT.setSelected(true);
        } else {
            udpBT.setSelected(true);
        }
        
        
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(tmpPanel, gc);
		serverPanel.add(tmpPanel);


        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        JEditorPane statusLB = new JEditorPane("text/html",
                "<font face=\"arial\">I3 Server status URL"
                );
        statusLB.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        statusLB.setMaximumSize(new Dimension(400,40));
        tmpPanel.add(statusLB);
        
        tmpPanel.add(new HelpButton("HELP_STATUS_URL", this));
        
        

		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(tmpPanel, gc);
		serverPanel.add(tmpPanel);


        statusTF = new JTextField(20);
        statusTF.setMaximumSize(new Dimension(300,20));
        statusTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
        statusTF.setText(overlay.statusURL);
        statusTF.getDocument().addDocumentListener(changeListener);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		gbag.setConstraints(statusTF, gc);
		serverPanel.add(statusTF);
        
        
        		
        
        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 1.0;
		gbag.setConstraints(tmpPanel, gc);
        serverPanel.add(tmpPanel);

        JEditorPane knownServersLB = new JEditorPane("text/html",
                "<font face=\"arial\">List of known I3 Servers"
                );
        knownServersLB.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        knownServersLB.setMaximumSize(new Dimension(400,20));
        knownServersLB.setEditable(false);
        tmpPanel.add(knownServersLB);
        
        tmpPanel.add(Box.createHorizontalGlue());

        tmpPanel.add(new HelpButton("HELP_KNOWN_LIST", this));
        
        
        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        
        
        knownServerCombo = new JComboBox();
        knownServerCombo.setMaximumSize(new Dimension(250,20));
        knownServerCombo.setMinimumSize(new Dimension(250,20));
        knownServerCombo.setPreferredSize(new Dimension(250,20));
        knownServerCombo.setBackground(ProxyConfig.INPUT_BOX_COLOR);
        knownServerCombo.addItemListener(changeListener);
        tmpPanel.add(knownServerCombo);

        gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 1.0;
		gbag.setConstraints(tmpPanel, gc);
        serverPanel.add(tmpPanel);

        
        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);
        
        JButton editKnownServerBT = new JButton("MODIFY");
        editKnownServerBT.addActionListener(this);
        editKnownServerBT.setActionCommand("EDIT_SERVER");
        tmpPanel.add(editKnownServerBT);
        
        tmpPanel.add(Box.createRigidArea(new Dimension(5,5)));
        
        JButton addKnownServerBT = new JButton("ADD NEW");
        addKnownServerBT.addActionListener(this);
        addKnownServerBT.setActionCommand("ADD_SERVER");
        tmpPanel.add(addKnownServerBT);
        
        tmpPanel.add(Box.createRigidArea(new Dimension(5,5)));
        
        JButton delKnownServerBT = new JButton("REMOVE");
        delKnownServerBT.addActionListener(this);
        delKnownServerBT.setActionCommand("DEL_SERVER");
        tmpPanel.add(delKnownServerBT);
        
        
        tmpPanel.add(Box.createHorizontalGlue());

        gc.gridx = 1;
		gc.gridy = 3;
		gc.weightx = 1.0;
		gbag.setConstraints(tmpPanel, gc);
        serverPanel.add(tmpPanel);


        ListIterator itr = overlay.i3KnownServerList.listIterator();
        while (itr.hasNext()) {
            I3Server tmpServer = (I3Server) itr.next();
            knownServerCombo.addItem(tmpServer);
        }
        
        add(Box.createVerticalGlue());
        
        changeListener.setEnabled(true);

    }
    
    public void actionPerformed (ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        if (cmd.equals("UDP")) {
           	overlay.i3UseTCP = false;
           	
        } else if (cmd.equals("TCP")) {
        
           	overlay.i3UseTCP = true;
           	
        } else if (cmd.equals("EDIT_SERVER")) {
            
            ProxyConfig.changeOptionPaneBackground(Color.WHITE);
            
            I3Server currServer = (I3Server) knownServerCombo.getSelectedItem();
            if (currServer != null) {
                I3ServerEditPanel i3ServerEditPanel = new I3ServerEditPanel();
                i3ServerEditPanel.setServer(currServer);
                
                
                int retVal = JOptionPane.showConfirmDialog(null, 
                        i3ServerEditPanel, "Modify I3 Server", JOptionPane.OK_CANCEL_OPTION);
                if (retVal == JOptionPane.OK_OPTION) {
                    
                    if (i3ServerEditPanel.checkFields()) {
                        i3ServerEditPanel.updateServer(currServer);
                        changeListener.setChanged(true);
                    }
                }
                
                ProxyConfig.restoreOptionPaneBackground();
            } else {
                ProxyConfig.beep();
            }
            
        } else if (cmd.equals("ADD_SERVER")) {

            ProxyConfig.changeOptionPaneBackground(Color.WHITE);

            I3ServerEditPanel i3ServerEditPanel = new I3ServerEditPanel();
            
            int retVal = JOptionPane.showConfirmDialog(null, i3ServerEditPanel, "Enter details of the new Server", JOptionPane.OK_CANCEL_OPTION);
            if (retVal == JOptionPane.OK_OPTION) {

                if (i3ServerEditPanel.checkFields()) {
                    	
                    I3Server currServer = new I3Server();
                    if (i3ServerEditPanel.updateServer(currServer)) {
                        knownServerCombo.addItem(currServer);
                        overlay.i3KnownServerList.add(currServer);
                        changeListener.setChanged(true);
                    }
                }
            }
            
            ProxyConfig.restoreOptionPaneBackground();
        } else if (cmd.equals("DEL_SERVER")) {

            I3Server currServer = (I3Server) knownServerCombo.getSelectedItem();
            if (currServer != null) {
                int retVal = JOptionPane.showConfirmDialog(null, 
                        "Are you sure you want to delete the i3 server [" + currServer + "] ?", 
                        "Confirm Delete", JOptionPane.YES_NO_OPTION);
                if (retVal == JOptionPane.YES_OPTION) {
                    knownServerCombo.removeItem(currServer);
                    overlay.i3KnownServerList.remove(currServer);
                    changeListener.setChanged(true);
                }
                
            } else {
                ProxyConfig.beep();
            }
        
            
        } else if (cmd.equals("HELP_STATUS_URL")) {
            
            JOptionPane.showMessageDialog(null, 
                    "The proxy obtains a list of active I3 servers from the specified URL." +
                    "\nThis list of I3 servers is used if the list of known I3 servers is" +
                    "\nempty",
                    "HELP: I3 Status URL",
                    JOptionPane.INFORMATION_MESSAGE
                    
                    );
                    
        } else if (cmd.equals("HELP_PROTOCOL")) {
            JOptionPane.showMessageDialog(null, 
                    	"The proxy can use either TCP or UDP to communicate with the I3 servers." +
                    	"\nIf you are behind a firewall that blocks UDP packets, you must choose " + 
                    	"\nTCP here.",
                    	"HELP: Protocol to contact I3 servers",
                    	
                    	JOptionPane.INFORMATION_MESSAGE
                    );
        } else if (cmd.equals("HELP_KNOWN_LIST")) {
            
            JOptionPane.showMessageDialog(null, 
                    "This is a list of I3 servers the proxy already knows about."
                    + "\nThis means that the IP addresses and I3 port numbers of these I3 servers are known.",
                    "HELP: List of known I3 Server",
                    JOptionPane.INFORMATION_MESSAGE
            
            	);
        }

     }

    void update() {
        overlay.statusURL = statusTF.getText();
        
    }
    
    boolean checkFields() {
        
        String msg = "";
        boolean retVal = true;
        
        if (statusTF.getText().trim().equals("") && knownServerCombo.getItemCount() ==0) {
            msg = "You should specify an i3 status URL or at least one known i3 server.\n";
            retVal = false;
        }
        
        if (!retVal) {
            
            JOptionPane.showMessageDialog ( null,
                    msg, "Error", JOptionPane.ERROR_MESSAGE);
      
        }
        return retVal;
    }
}


