/*
 * Created on Jan 22, 2005
 */
package proxyconfig.i3;

import javax.swing.*;

import proxyconfig.HelpButton;
import proxyconfig.InputChangeListener;

import java.awt.*;
import java.awt.event.*;

/**
 * @author danjo
 */
public class NameResolutionPanel extends JPanel implements ActionListener {

    I3OCD overlay;
    I3AddressBookPanel addressBookPanel;
    
    InputChangeListener changeListener;
    
    NameResolutionPanel (I3OCD overlay, InputChangeListener changeListener) {
        this.overlay = overlay;
        this.changeListener = changeListener;
        
        changeListener.setEnabled(false);
        //setBorder(BorderFactory.createLineBorder(Color.BLACK));
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);

        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        add(Box.createVerticalGlue());

        JPanel tmpPanel;
        
        tmpPanel = new JPanel();
        tmpPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);

        JEditorPane headingLB = new JEditorPane();
        tmpPanel.add(headingLB);
        headingLB.setContentType("text/html");
        headingLB.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        headingLB.setText("<font face=\"arial\"><h2 color=\"blue\">Address Book</h2>");
        headingLB.setMaximumSize(new Dimension(400,40));
        headingLB.setEditable(false);
        
        
        tmpPanel.add(new HelpButton("HELP_NAME_RES", this));
        
        tmpPanel.add(Box.createHorizontalGlue());
        
        add(Box.createRigidArea(new Dimension(10,10)));

        addressBookPanel = new I3AddressBookPanel(overlay, changeListener);
        add(addressBookPanel);
        
        add(Box.createVerticalGlue());
        changeListener.setEnabled(true);
    }
    
    public void actionPerformed (ActionEvent ae) {
        String cmd = ae.getActionCommand();
        
        if (cmd.equals("HELP_NAME_RES")) {
            
            JOptionPane.showMessageDialog( null, 
                    "The proxy uses the entries in the address book to convert names like \"xyz.i3\" to" +
                    "\ntheir corresponding I3 ids. ",
                    "HELP: Name Resolution.",
                    JOptionPane.INFORMATION_MESSAGE
            	);
        }
    }
    
    void update() {
        addressBookPanel.update();
    }
}
