/*
 * Created on Oct 9, 2005
 */
package proxyconfig.ocd;

import proxyconfig.*;

/**
 * Base class for different OCD configuration wizards.
 * @author danjo
 */
public abstract class OCDWizardDialog extends WizardDialog {

     public OCDWizardDialog(ProxyConfig proxyConfig, String wizardTitle) {
         super(proxyConfig, wizardTitle);
                
     }
     
     /** Did the user OK the changes made using the wizard? 
      * @return true if yes.
      */
     abstract public boolean isOK();
     
     /** Did the user make any changes to the configuration
      * using the wizard
      * @return true if yes.
      */
     abstract public boolean hasChanged();
     
     /** Update the OCD from the onscreen data */
     abstract public void update();
     
     /** Check if the fields of the wizard have been filled up in some sane manner. */
     abstract public boolean checkFields();
     
}
