/*
 * Created on Apr 12, 2006
 */
package proxyconfig.rsptunnelocd;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ListIterator;

import proxyconfig.ocd.*;

import org.xml.sax.SAXException;

import java.util.*;

import javax.swing.JOptionPane;

/**
 * @author danjo
 */
public class RSPTunnelOCD extends OCD {

    int myPortNum;
    ArrayList rspDomainList;
    String gatewayDownPolicy;
    
    public RSPTunnelOCD () {
        rspDomainList = new ArrayList();
        
    }
    
    public void init (OCD o) {
        super.init (o);
        File tmpFile = new File(configFile);
        if ( ! tmpFile.exists()) {
            JOptionPane.showMessageDialog(null, 
                    "I3 Config File " + configFile + " not found",
                    "File Not Found",
                    JOptionPane.ERROR_MESSAGE
                   );
        } else {
        
            try {
                new ConfigFileReader(this);
            } catch (SAXException sxe) {
                JOptionPane.showMessageDialog( 
                        null,
                        "Error while parsing " + configFile  + ".\n" + sxe,
                        "Parsing Error",
                        JOptionPane.ERROR_MESSAGE
                       );                        
            }
        }
    }
    
    public void writeToDisk() throws IOException {
        writeConfigFile();
    }
    
    private void writeConfigFile() throws IOException {
//      write the basic i3 config file.

        String rspDomainListStr = "";
        ListIterator domainItr = rspDomainList.listIterator();
        while (domainItr.hasNext()) {
            String currDomain = (String) domainItr.next();
            rspDomainListStr += currDomain.trim();
            if (domainItr.hasNext()) {
                rspDomainListStr += ",";
            }
        }
        BufferedWriter bw = new BufferedWriter (new FileWriter(configFile));
        bw.write("<?xml version=\"1.0\"?>\n");
        bw.write("<RSPTunnelOCDConfigFile \n" +
                	"\t\tmyPortNum = \"" + myPortNum + "\"\n" +
                	"\t\trspDomainList = \"" + rspDomainListStr + "\"\n" +
                	"\t\tgatewayDownPolicy = \"" + gatewayDownPolicy + "\"\n" +
                	">\n");
        
        bw.write("\t</RSPTunnelOCDConfigFile>\n");        bw.close();
    }

}
