#ifndef DNS_REPLY_CALLBACK_H
#define DNS_REPLY_CALLBACK_H 1

#include "common.h"

/**
  * This class is used an interface for DNS Reply callbacks.
  * You register an object implementing this interface with Proxy::makeDNSRequest.
  * When the DNS reply arrives, the receivedDNSReply(ipaddress) function of the object is invoked.
  */
class DNSReplyCallback {

protected:
    uint16_t dnsTransactionId;
public:  

    /** This function is called when a DNS response for which this object was registered
      * as the callback is received.
      * @param resolvedIP the resolved IP address in host byte format.
      */
    OCALA_LIB_EXPORT_IMPORT virtual void receivedLegacyDNSReply(uint32_t resolvedIP)=0;

    friend class Proxy;
};
#endif
