/**
 *  \file FDCallback.h
 *  \brief Declaratio of a file descriptor callback function.
*/

#ifndef FD_CALLBACK_H
#define FD_CALLBACK_H 1

class TFunctor;

/**
  * This class encapsulates a file descriptor and the pointer to the function
  * to be called when data is available on the file descriptor.
  */
class  FDCallback {
    int fd;
    TFunctor *functor;
    
    /** If this flag is set to true, the callback is not executed when the call() is invoked*/
    bool disabledFlag;

    /**
      * Should the TFunctor be freed when the FDCallback is deleted.
      */
    bool cbkFreeFlag;

    
    FDCallback(int fd, int (*ordinaryFnPtr)(char *));
    FDCallback(int fd, TFunctor *, bool cbkFreeFlag);
    void call();  

    ~FDCallback();
public:

    friend class Proxy;
};
#endif
