/**
 *  \file FakeAddressNegotiationBlocks.h
 *  \brief Packet formats of the messages exchanged for negotiating the fake ip address.
*/
#ifndef FAKE_ADDRESS_NEGOTIATION_BLOCKS
#define FAKE_ADDRESS_NEGOTIATION_BLOCKS

#include "oci/OCIPacketBlock.h"

/** Message code to indicate a request for a particular fake IP address */
#define FAKE_ADDRESS_NEGOTIATION_REQUEST        1

/** Message code to indicate that the requsted fake IP address was allocated */
#define FAKE_ADDRESS_NEGOTIATION_REPLY_YES      2

/** Message code to indicate that the requested fake IP address could NOT be allocated. */
#define FAKE_ADDRESS_NEGOTIATION_REPLY_NO       3


/**
  * Top level Fake Address Negotiation Block 
  */
typedef struct {
    
    /** The main proxy packet block header goes here. */
    OCIPacketBlock mainHeader;

    /** What type of message? = FAKE_ADDRESS_NEGOTIATION_REQUEST, .. */
    int msgCode;

    /** The fake IP address which is being requested */
    in_addr requestedAddr;

} FakeAddressNegotiationBlock;

#endif
