/**
 *  \file JournalRecord.h
  * \brief This class is used to provide a common interface through
  * which the journal record corresponding to state information of different
  * layers (OCI, various OCDs) etc can be extracted at time of flushing the
  * journal to disk.
  */
#ifndef JOURNAL_RECORD_H
#define JOURNAL_RECORD_H

 /* 
  * \brief This class is used to provide a common interface through
  * which the journal record corresponding to state information of different
  * layers (OCI, various OCDs) etc can be extracted at time of flushing the
  * journal to disk.
  */
class JournalRecord {

public:

    /**
      * This function writes out the journal record to the specified buf.
      * The total lenght of the record must be less than MAX_JOURNAL_RECORD_LEN.
      */
    virtual void getJournalRecord (char *buf) {
        // Dummy, must overload
        strcpy (buf, "ERROR: Function getJournalRecord not correctly overloaded.\n");
        
    }
};

#endif
