/**
 * \file MyName.cpp
 * \brief This file defines the MyName object and its various properties.
 * A MyName object represents a name associated with this proxy instantiation.
*/
#include "MyName.h"

MyName::MyName (string name) {

    this->name = name;
}

/**
  * Add the specified attribute value pair.
  */
void MyName::addProperty (char *propName, char *propValue) {

    string tmpStr = propName;
    ocdProperties.insert (pair<string, char *> (tmpStr, strdup(propValue)));
    
}

/**
  * Finds the name of the specified property.
  * Returns NULL if not found.
  */
char* MyName::getProperty (char *propName) {

    string tmpStr = propName;
    map<string, char*>::iterator itr = ocdProperties.find (tmpStr);
    
    if (itr != ocdProperties.end()) {
        return itr->second;
        
    } else {
            
        return NULL;
    }
}
