/**
 *  \file MyName.h
 *  \brief Defines the properties of a name associated with the proxy.
*/

#ifndef MY_NAME_H
#define MY_NAME_H

#include "OCALA_Export.h"

#include <map>
#include <string>
using namespace std;

/** Encapsulates an inbound name and its properties.
  */
class MyName {

public:
    /** The DNS like name */
    string name;

    /** The OCD with which this name is associated */
    string ocdId;

    /** Map containing ocd specific name value pairs associated with this name */
    map<string, char *> ocdProperties;

    OCALA_LIB_EXPORT_IMPORT MyName (string name);
    OCALA_LIB_EXPORT_IMPORT void addProperty (char *propName, char *propValue);
    OCALA_LIB_EXPORT_IMPORT char *getProperty (char *propName);

    friend class MyNameConfigFile;
};

#endif
