/**
 *  \file MyNameConfigFile.h
 *  \brief Definition of the various XML tags used in the myNames.xml 
 * file as well as the declaration of the parser.
*/

#ifndef MY_NAME_CONFIG_FILE_H
#define MY_NAME_CONFIG_FILE_H 1

#include "ConfigFile.h"
#include <list>

#define MY_NAME_ROOT_TAG        "MyNameList"
#define XPATH_MY_NAME           "//MyName"
#define ATTRIB_MY_NAME_NAME     "name"
#define ATTRIB_MY_NAME_ACTIVE   "active"
#define ATTRIB_MY_NAME_OCD_ID   "ocdId"
#define ATTRIB_MY_NAME_CERTIFICATE   "certificate"

using namespace std;

class Proxy;

/**
  * This file is used to parse the list of my names (inbound names).
  * Each name is added to the appropriate ocd.
  */
class MyNameConfigFile:public ConfigFile {

public:
    MyNameConfigFile(string fileName, string rootTag);   

    void loadNameList(Proxy* proxy);

};

#endif
