#!/usr/bin/perl
# This script does multiple DNS lookups and reports the total time taken.

use strict;
use Socket;

my @namesToLookup = (   "www.yahoo.com",
                        "www.google.com",
                        "www.berkeley.edu",
                        "dilu.tripod.com",
                        "www.mit.edu",
                        "www.princeton.edu",
                        "www.washington.edu",
                        "www.news.com",
                        "www.rediffmail.com",
                        "danjo.cs.berkeley.edu",
                        "rose.cs.berkeley.edu",
                        "violin.cs.berkeley.edu",
                        "www.walmart.com",
                        "www.yahoo.co.in",
                        "www.orbitz.com",
                        "www.whitehouse.gov",
                        "www.nasa.gov"
                    );

my $startTime = time;

foreach (@namesToLookup) {
    print "Looking up $_: ";
    
    my $addr;
    ($addr) = (gethostbyname($_))[4];
    my $tmpIP =  join(".",unpack("C4", $addr));
    print "$tmpIP\n";
}

my $endTime = time;

my $timeDiff = $endTime - $startTime;

print "Total time taken = $timeDiff seconds\n";

