#!/usr/bin/perl

use strict 'vars';
package main;

use Getopt::Std;

my %time = ();
my $max_index = 0;

while (<>) {
    chomp $_;
    $_ =~ s/^[ \t]+//gm; $_ =~ s/[ \t]+$//gm;
    my @opts = split(/ +/, $_);

    if (int(scalar(@opts)) == 4) {
	$time{$opts[3]}[$opts[2]] = $opts[1];
    }

    if ($opts[2] > $max_index) {
	$max_index = $opts[2];
    }
}

my $i, my $temp, my $prpu;
for ($i = 0; $i <= $max_index; $i++) {
    
    print "ID $i";
    
    # send
    if (defined($time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_E"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_E"}[$i];
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PRIVATE_TRIGGER_E"}[$i];
    }
    print " SendTotal-$prpu ".(-$time{"UDP_SEND_START"}[$i] + $temp);

    print " AppSend ".(-$time{"UDP_SEND_START"}[$i] + $time{"UDP_SEND_END"}[$i]);

    print " AppToTun ".($time{"DATA_PKT_CAPTURED_FROM_TUN"}[$i] - $time{"UDP_SEND_END"}[$i]);
    
    if (defined($time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_S"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_S"}[$i];
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PRIVATE_TRIGGER_S"}[$i];
    }    
    print " TunToO-$prpu ".($temp - $time{"DATA_PKT_CAPTURED_FROM_TUN"}[$i]);

    if (defined($time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_S"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_E"}[$i]
		- $time{"DATA_PKT_SENT_TO_OVERLAY_PUBLIC_TRIGGER_S"}[$i];
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_SENT_TO_OVERLAY_PRIVATE_TRIGGER_E"}[$i]
		- $time{"DATA_PKT_SENT_TO_OVERLAY_PRIVATE_TRIGGER_S"}[$i];
    }    
    print " OverSend-$prpu ".$temp;


    # recv
    if (defined($time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_S"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_S"}[$i];
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PRIVATE_TRIGGER_S"}[$i];
    }
    print " RecvTotal-$prpu ".($time{"UDP_ECHO_RECV_END"}[$i] - $temp);

    if (defined($time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_S"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_E"}[$i];
		- $time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_S"}[$i]
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PRIVATE_TRIGGER_E"}[$i]
		- $time{"DATA_PKT_RCVD_FROM_OVERLAY_PRIVATE_TRIGGER_S"}[$i];
    }    
    print " OverRecv-$prpu ".$temp;
    
    if (defined($time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_E"}[$i])) {
	$prpu = "PU";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PUBLIC_TRIGGER_E"}[$i];
    } else {
	$prpu = "PR";
	$temp = $time{"DATA_PKT_RCVD_FROM_OVERLAY_PRIVATE_TRIGGER_E"}[$i];
    }
    print " OToTun-$prpu ".($time{"DATA_PKT_SENT_TO_APPLICATION_S"}[$i] - $temp);
    
    print " TunToApp ".($time{"UDP_ECHO_RECV_END"}[$i] - $time{"DATA_PKT_SENT_TO_APPLICATION_S"}[$i]);

    print " AppRecv ".($time{"UDP_ECHO_RECV_END"}[$i] - $time{"UDP_ECHO_RECV_START"}[$i]);
    
    print "\n";
}
