/**
 *  \file CompressionBlackBox.cpp
 *  \brief The functions to compress and decompress data.
 */
#define ZLIB_DLL 1
#include "CompressionBlackBox.h"

/**
  * Compress plain data. Put the output in compressed data.
  * @param compressedDataLen will contain the length of the compressed data on exit.  However it must be initially set to the size of the compressedData buffer. The compressedDataBuffer should be atleast 0.1% + 12 bytes larger than plainData buffer!
  */
void CompressionBlackBox::compress (
                const char *plainData, unsigned long plainDataLen, 
                char *compressedData, unsigned long *compressedDataLen, int compressionLevel) {


    //TODO compress2 ((Bytef *)compressedData, compressedDataLen, (Bytef *)plainData, plainDataLen, compressionLevel);

    /*
    Bytef *dest = (Bytef *) compressedData;
    uLongf *destLen = compressedDataLen;
    Bytef *source = (Bytef *) plainData;
    uLongf sourceLen = plainDataLen;
    int level = this->compressionLevel;
    
    // Start: Code copied from zlib library 
    z_stream stream;
    int err;

    stream.next_in = (Bytef*)source;
    stream.avail_in = (uInt)sourceLen;
#ifdef MAXSEG_64K
    // Check for source > 64K on 16-bit machine: 
    if ((uLong)stream.avail_in != sourceLen) return Z_BUF_ERROR;
#endif
    stream.next_out = dest;
    stream.avail_out = (uInt)*destLen;
    if ((uLong)stream.avail_out != *destLen) return Z_BUF_ERROR;

    stream.zalloc = (alloc_func)0;
    stream.zfree = (free_func)0;
    stream.opaque = (voidpf)0;

    err = deflateInit2(&stream, level, Z_DEFLATED, -14, 8, Z_DEFAULT_STRATEGY); // Dilip modified this line to avoid adding zlib trailer
    if (err != Z_OK) return err;

    err = deflate(&stream, Z_FINISH);
    if (err != Z_STREAM_END) {
        deflateEnd(&stream);
        return err == Z_OK ? Z_BUF_ERROR : err;
    }
    *destLen = stream.total_out;

    err = deflateEnd(&stream);
    return err;

    // End: Code copied from zlib library
    */

}


/** 
  * Decompress compressed data and put the output in plain data.
  * @param plainDataLen will be used to return the length of the decompressed data. However it must initialized to the size of the plain data buffer.
  */
void CompressionBlackBox::decompress (
        const char *compressedData, unsigned long compressedDataLen,
        char *plainData, unsigned long *plainDataLen) {

    //TODO uncompress ((Bytef *)plainData, plainDataLen, (Bytef *)compressedData, compressedDataLen);

}

CompressionBlackBox::CompressionBlackBox () {
    //Dummy
}
