/**
 * \file CompressionBlackBox.h
 * \brief Just a blackbox interface to easily compress/decompress data.
 */
#ifndef COMPRESSION_BLACK_BOX_H 
#define COMPRESSION_BLACK_BOX_H 1

extern "C" {

    #include <zlib.h>
}

/**
  * This is a wrapper class for zlib compression functions. 
  */
class CompressionBlackBox {

public:
   
    CompressionBlackBox ();

    void compress (const char *plainData, unsigned long plainDataLen, char *compressedData, unsigned long * compressedDataLen, int compresionLevel);
    void decompress (const char *compressedData, unsigned long compressedDataLen, char* plainData, unsigned long * plainDataLen);
};

#endif
