/**
 *  \file CompressionPacketBlocks.h
 *  \brief The packet format used in the protocol to 
 *  negotiate compression parameters.
*/
#ifndef COMPRESSION_PACKET_BLOCKS_H
#define COMPRESSION_PACKET_BLOCKS_H

#include "../oci/OCIPacketBlock.h"

#define COMPRESSION_BLOCK_REQUEST       1
#define COMPRESSION_BLOCK_REPLY_OK      2
#define COMPRESSION_BLOCK_REPLY_FAIL    3

#define COMPRESSION_SCHEME_ZLIB         1

typedef struct {

    /** The main proxy packet block header */
    OCIPacketBlock mainHeader;

    /** What is this request about? */
    int msgCode;

    /** The compression scheme requested */
    int compressionScheme;
    
    /** The level of compression requested or acknowledged */
    int compressionLevel;

} CompressionPacketBlock;

#endif
