/**
 *  \file testCompressionState.cpp
 *  \brief  This file contains a program to test the compresson/decompression operations.
 */

#include "CompressionBlackBox.h"

#include <string.h>
#include <stdio.h>

int main () {

    char in1 [100];
    char in2 [100];
    char out [100];

    strcpy (in1, "Hello Compressed World Hello Compressed World\n");
    
    printf ("Compressing the folowing string containing %d character:\n%s\n", strlen (in1), in1);

    unsigned long compressedLen = sizeof (out);

    CompressionBlackBox compr;

    compr.compress (in1, strlen (in1) + 1, out, &compressedLen, 6 /* compression level */);
    printf ("Data compressed to %d bytes\n", compressedLen);

    unsigned long in2Len = sizeof (in2);
    compr.decompress (out, compressedLen, in2, &in2Len);

    printf ("Length of decompressed data = %d\n", in2Len);
    if (strcmp (in1, in2) == 0) {
        printf ("Original string and decompressed string match!\n");
    } else {
        printf ("MISMATCH between original string and decompressed string!\n");
    }
    
}
