#include <stdlib.h>
#include <stdio.h>

#include "BlackList.h"

/**
  * Test program for the BlackList class.
  * Input: the forbidden list and the list of URLs to lookup.
  */
int main (int argc, char* argv[]) {

    if (argc < 2) {
        printf ("Usage: %s <forbiddenListFile> <url to look up 1> <url to look up 2>\n", argv[0]);
        exit (-1);
    }

    BlackList blackList (argv[1]);

    blackList.dumpForbiddenList();
    
    for (int i = 2; i < argc; i++) {
        printf ("%s : ", argv[i]);
        if (blackList.isBlackListed (argv[i])) {
            printf ("BLACK LISTED\n");
        } else {
            printf ("clean\n");
        }
    }
}
