/**
 *  \file BroState.h
 *  \brief Definition of the state maintained by the bro middlebox 
 *  for each connection passing through it.
 */

#ifndef BRO_STATE_H
#define BRO_STATE_H

#include <stddef.h>
#ifdef __APPLE__
#include <sys/types.h>
#endif
#include <netinet/in.h>
#include <arpa/inet.h>

class BroState {

public:
    /** The IP address to be rewritten in the source field of packets in this flow */
    struct in_addr srcAddr;
    
    /** The IP address to be rewritten in the destination field of packets in this flow */
    struct in_addr dstAddr;
   
    BroState (struct in_addr srcAddr, struct in_addr dstAddr);

};
#endif
