#ifndef REGISTRY_PARAMS_H
#define REGISTRY_PARAMS_H

/** The name of the OCALA proxy service 
 *  We must ensure that this name matches what the proxy actually
 *  uses while registering the service.
 */
#define OCALA_SERVICE_NAME "OCALA Proxy"

/** The proxy monitor looks for registry entries under the key
 * HKEY_LOCAL_MACHINE\Software\REGISTRY_APP_NAME.
 * We must ensure that when the OCD modules put their status information in,
 * they use the same values for REGISTRY_APP_NAME.
 */
#define REGISTRY_APP_NAME		"OCALA"


/** The maximum length of string values in our registry entries */
#define MAX_REGISTRY_STR_VALUE_LEN 1000

// Name of values used in our registry entires
#define REGISTRY_STATUS_MSG		"statusMsg"
#define REGISTRY_STATUS_CODE	"statusCode"
#define REGISTRY_OCD_DESCRIPTION "description"
#define REGISTRY_OCD_TYPE		"type"
#define REGISTRY_OCD_CURR_ICON_NAME	"currIconName"
#define REGISTRY_OCD_ICON_LIST	"iconList"
#define ERROR_MSG_READING_REGISTRY "Error while reading registry value"

#define REGISTRY_OCD_BALLOON_MSG "balloonMsg"

#endif // REGISTRY_PARAMS_H