/**
 *  \file OCIKeepAliveState.h
 *  \brief This file declares the OCIKeepAliveState info object.
 */

#ifndef OCI_KEEP_ALIVE_STATE_H
#define OCI_KEEP_ALIVE_STATE_H

#include "OCIPacketBlock.h"

class TimerEvent;
class OCIState;

class OCIKeepAliveState {

    /** The current inter KeepAlive message period (in milli seconds) */
    int currSendPeriod;

    /** The amount of time for KeepAlive Reply message (in milli seconds) */
    int currReplyPeriod;
    
    /** The OCI state served by this keep alive state */
    OCIState* ociState;
   
    /** The next send event */ 
    TimerEvent* sendTimer;

    /** The next reply not recevied on time  timeout */
    TimerEvent* replyTimer;
    

    void replyTimerExpired();
    void sendTimerExpired();

    OCIKeepAliveState(OCIState *);
    ~OCIKeepAliveState();

    void receivedKeepAliveReply();

    void start();

    friend class OCIState;
    friend class OCI;

};

#endif
