/**
 *  \file utils.c
 *  \brief Generic string utility functions (should probably shifted to a file in some central utils directory.
*/

#include <string.h>
#include <stdlib.h>

#include "cryptoFunctions.h"

/**
  * Strips the leading and trailing whitespaces.
  * If the entire string is just white space,  "" is copied to msg
  */
OCALA_LIB_EXPORT_IMPORT void stripWhiteSpace (char *msg) {

    int len = strlen(msg);
    
	int j = 0;
	int k = 0;
    int i = 0;
	while ( i < len && (msg[i] == ' ' || msg[i] == '\t' || msg[i] == '\n')) {
        i++;
    }

    if (i > (len - 1)) {
        //the entire string is just whitespace.
        strcpy (msg, "");
        return;
    }

    //strip all trailing blanks
   j = len - 1;
    while ( j >= i && (msg[j] == ' ' || msg[j] == '\t' || msg[j] == '\n')) {
        j--;
    }

    
    while ( i <= j) {
        msg[k] = msg[i];
        i++;
        k++;
    }

    msg[k] = '\0';

    
}

/** Strips the last new line if any */
OCALA_LIB_EXPORT_IMPORT void stripNL (char *msg) {
    int len = strlen (msg);
    if (msg[len - 1] == '\n') {
        msg[len - 1] = '\0';
    }
}

/** Generates a random string of length strLen into str 
 * The string is null terminated.
 */
OCALA_LIB_EXPORT_IMPORT void generateRandomString (char *str, int strLen) {

    int i;
	int randomChar;
    
    int low = 65;   //ASCII code of !
    int high = 90; //ASCII code of }
   
    int randNum;

    // This should probably not be here.  But without this,
    // there is no randomness.  I don't know why.  
    //cryptoInit();

    for (i = 0; i < strLen; i++) {
    	randNum = rand();
        randomChar = (int) (( (1.0 * randNum)/RAND_MAX) * (high - low) + low);
        str[i] = (char) randomChar;
    }
    str[strLen - 1] = '\0';
}


