/**
 *  \file db.h
 *  \brief Database functions declarations.
*/

#ifndef SECURITY_DB_H
#define SECURITY_DB_H 1

#include "../lib/certificate.h"

#define NAME_ALLOCATION_TABLE "AllocatedNames"
#define COL_NAME "name"
#define COL_REAL_NAME "realName"
#define COL_EMAIL_ADDR "emailAddr"
#define COL_SIGN    "sign"
#define COL_SIGN_LEN "signLen"
#define COL_PUB_KEY "publicKey"
#define COL_PUB_KEY_LEN "publicKeyLen"
#define COL_EMAILED_PASSWORD "emailedPassword"
#define COL_REVOKE_PASSWORD "revokePassword"
#define COL_VERIFIED_FLAG "verifiedFlag"

void initDBConnection(char *dbName, char *hostName, char *userName, char *password);

void closeDBConnection();

int addNewNameRecord (  char *name, char *realName, char *emailAddr, 
                        unsigned char *publicKey, unsigned int publicKeyLen,
                        char *emailedPassword, char *revokePassword, 
                        int verifiedFlag
                    );

int  setNameSigned ( char *name, unsigned char* sign, unsigned int signLen);

#define NAME_EXISTS_EMAIL_SAME 	100
#define NAME_EXISTS_EMAIL_DIFF 	200
#define NAME_NO_EXIST	0
int checkIfNameExists(char *name, char *email);
int checkIfNameVerified(char *name);
int checkNamePassword(char *name, char *password);

int  loadCertificateFromDB (char *name, Certificate *cert);


#endif
