#include <stdio.h>
#include <string.h>

#include "../lib/cryptoHeaders.h"
#include "../lib/cryptoFunctions.h"
#include "../lib/certificate.h"
    
#include "../lib/securityCommon.h"
#include "../lib/utils.h"


int main ()
{
    
    //char randomStr[100];
    //generateRandomString(randomStr, 100);
    //printf("random string = %s\n", randomStr);


    unsigned char sigBuf [MAX_SIGN_BUF_SIZE];
    uint16_t sigLen;
    
    static char data[]     = "I owe you...";
    
    cryptoInit();
    EVP_PKEY* privateKey = initPrivateKey(CA_PRIVATE_KEY_FILE);
    EVP_PKEY* publicKey = initPublicKey(CA_CERT_FILE);

    RSA* keypair = generateKeyPair();
    RSA* pubKey = getPublicKeyFromPair(keypair);
    Certificate* newCert = constructNewCertificate("dilip", "Dilip Antony", "dilip@cs.berkeley.edu", pubKey);
  
    printf_certificate(newCert);

    unsigned char privKeyBuf[2000];
    int privKeyLen = savePrivateKeyToBuffer(keypair, privKeyBuf, 2000);
    RSA* privKeyFromBuf = loadPrivateKeyFromBuffer(privKeyBuf, privKeyLen);
    
    EVP_PKEY* privateKey2 = EVP_PKEY_new();
    if (!EVP_PKEY_assign_RSA(privateKey2, privKeyFromBuf)) {
        printf(
                "Unable to assign RSA private key to EVP key.\n"
                );
	    ERR_print_errors_fp(stderr);
    }
     
    EVP_PKEY* publicKey2 = EVP_PKEY_new();
    if (!EVP_PKEY_assign_RSA(publicKey2, pubKey)) {
        printf(
                "Unable to assign RSA public key to EVP key.\n"
                );
	    ERR_print_errors_fp(stderr);
    }
    
    sign (data, strlen(data), sigBuf, &sigLen, privateKey2);
    
    if (verifySignature(data, strlen(data), sigBuf, sigLen, publicKey2)) {
        printf ("Signature Verified Ok.\n");
    } else {
        printf("Verification FAILED.\n");
    }
}
