#include <stdio.h>
#include <string.h>

#include "../lib/EncryptDecryptBlackBox.h"

#include "../lib/cryptoFunctions.h"

void runTest (EncryptDecryptBlackBox* box, char* msg, int msgLen) {
    
    uint16_t inLen1 = msgLen;
    uint16_t outLen1 = inLen1 + MAX_CIPHER_BLOCK_LENGTH;
    
    uint16_t encLen1;
    uint16_t decLen1;
    
    unsigned char* buf1 = new unsigned char[inLen1];
    unsigned char* encBuf1 = new unsigned char [outLen1];
    unsigned char* decBuf1 = new unsigned char[outLen1];

    strcpy ((char *)buf1, msg);
    
    printf ("Length of data to be encrypted (original data) = %d\n", inLen1);
    
    box->encrypt(buf1, inLen1,encBuf1, &encLen1);
    
    printf ("Length of encrypted buffer = %d\n", encLen1);

    //decrypt
    box->decrypt(encBuf1,encLen1, decBuf1, &decLen1);
    
    printf ("Length of decrypted data = %d\n", decLen1);
    if (decLen1 != inLen1) {
        printf ("\n\n\t\tLength of original data and decrypted data do not match.\n\n");
    } else {
        printf ("\nLengths match\n");

    }

    if (memcmp (buf1, decBuf1, inLen1) != 0) {
        printf ("\n\n\t\tOriginal data and decrypted data do NOT match!\n");
    } else {
        printf ("\n\n\t\tOriginal data and decrypted data match.\n");
    }
}


int main(int argc, char *argv[]) {

    unsigned char key[EVP_MAX_KEY_LENGTH];
    unsigned char iv[EVP_MAX_IV_LENGTH];
    generateRandomSymKey (key, iv);
    
    EncryptDecryptBlackBox box (key, iv);
   

    printf ("\n\ntest 1\n");
    runTest(&box, "hello", 100);
    printf ("\n\ntest 2\n");
    runTest(&box, "world", 200);
    printf ("\n\ntest 3\n");
    runTest(&box, "UC Berkeley", 300);
    printf ("\n\ntest 2\n");
    runTest(&box, "IIT Madras", 500);
}


