/**
  * This program is used to test RSA public key encryption and decryption.
  */

#include <openssl/evp.h>

#include "../lib/cryptoFunctions.h"

int main (int argc, char *argv[]) {

    unsigned char key[EVP_MAX_KEY_LENGTH];
    unsigned char iv[EVP_MAX_IV_LENGTH];
    generateRandomSymKey (key, iv);

    RSA* privateKey = loadPrivateKeyFromDisk ("my.privkey"); 
    Certificate cert;
    loadCertificateFromFile ("my.cert", &cert);
    RSA* publicKey = loadPublicKeyFromBuffer (cert->publicKeyBuf, cert->publicKeyLen);

    
    *encryptedSymKeyLen = RSA_public_encrypt (EVP_MAX_KEY_LENGTH,  key, encryptedSymKeyBuf, remotePublicKey, CRYPTO_STATE_RSA_PADDING);
}
