#include <stdlib.h>
#include <stdio.h>
#include "../lib/SecurityManager.h"

void usage () {
    
    printf ("\nUsage: testSecurityManager <securityLevel> <cert list file> <name to lookup> <CA cert file>\n");
}

int main(int argc, char *argv[]) {
    
    if (argc < 4) {
        usage();
        exit(0);
    }

    int level = atoi (argv[1]);
   
    FILE *fp = fopen ( argv[2], "r");
    if (fp == NULL) {
        printf ("Unable to load certificate list from file %s.\n", argv[2]);
        exit (0);
    }
    
    char tmpBuf [10000];
    fgets (tmpBuf, sizeof(tmpBuf), fp);
    fclose(fp);
    
    SecurityManager mgr (level, tmpBuf, argv[4]);

    mgr.printCertificateList();
   

    char *lookupName = argv[3];
    Certificate* lookupCert = mgr.getCertificate(lookupName);
    if (lookupCert == NULL) {
        printf ("Certificate with name %s not found.\n", lookupName);
    } else {
        printf ("Certificate found!\n");
        printf_certificate (lookupCert);
    }
    
}


