/**
 *  \file talker.c
 *  \brief program to send out UDP packets.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


int main(int argc, char *argv[])
{
    int sockfd;
    struct sockaddr_in their_addr; // connector's address information
    struct hostent *he;
    int numbytes;
	int portNum;
	
    if (argc != 4) {
        fprintf(stderr,"usage: talker hostname portnum message\n");
        exit(1);
    }

    if ((he=gethostbyname(argv[1])) == NULL) {  // get the host info
        perror("gethostbyname");
        exit(1);
    }

    if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
        perror("socket");
        exit(1);
    }

	portNum = atoi(argv[2]);
		
    their_addr.sin_family = AF_INET;     // host byte order
    their_addr.sin_port = htons(portNum); // short, network byte order
    their_addr.sin_addr = *((struct in_addr *)he->h_addr);
    memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct

    if ((numbytes=sendto(sockfd, argv[3], strlen(argv[3]), 0,
		     (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
        perror("sendto");
        exit(1);
    }

    printf("sent %d bytes to %s:%d\n", numbytes, inet_ntoa(their_addr.sin_addr), portNum);

    close(sockfd);

    return 0;
}
