/**
  * \file test_FakeAddressManager.cpp
  * \brief This file is used to test the FakeAddressManager.
  */
#include "../FakeAddressManager.h"
#include "../ConfigFile.h"
#include "../common.h"

int main() {
	ConfigFile * configFile = new ConfigFile("../proxy-config.xml",
					"ProxyConfigFile");
	
	//Assume you have only 2 fake ip addresses in pool.
	//set config file accordingly
	FakeAddressManager fakeMgr(configFile);

	IPAddress **ipArray = new IPAddress*[1000];
	for (int index = 0; index < 16; index++) {
		IPAddress *ip2 = fakeMgr.getNewFakeIP();
		if (ip2 != NULL) {
			PRINT_DEBUG(0, "newIP: %s\n", ip2->c_str());
			ipArray[index] = ip2;
		} else {
			PRINT_DEBUG(50, "%d - No more fake IP Addresses.\n", index);
		}
	}

	PRINT_DEBUG(50, "release IPs\n\n\n");
	fakeMgr.releaseFakeIP(ipArray[1]);
	fakeMgr.releaseFakeIP(ipArray[3]);
	fakeMgr.releaseFakeIP(ipArray[15]);
	fakeMgr.releaseFakeIP(ipArray[7]);
	fakeMgr.releaseFakeIP(ipArray[8]);
	
	IPAddress **ipArray2 = new IPAddress*[1000];
	for (int index = 0; index < 10; index++) {
		IPAddress *ip2 = fakeMgr.getNewFakeIP();
		if (ip2 != NULL) {
			PRINT_DEBUG(0, "newIP: %s\n", ip2->c_str());
			ipArray2[index] = ip2;
		} else {
			PRINT_DEBUG(50, "%d - No more fake IP Addresses.\n", index);
		}
	}

	fakeMgr.releaseFakeIP(ipArray[7]);
	fakeMgr.releaseFakeIP(ipArray[10]);
	fakeMgr.releaseFakeIP(ipArray[15]);
	fakeMgr.releaseFakeIP(ipArray[0]);
		for (int index = 0; index < 10; index++) {
		IPAddress *ip2 = fakeMgr.getNewFakeIP();
		if (ip2 != NULL) {
			PRINT_DEBUG(0, "newIP: %s\n", ip2->c_str());
			ipArray2[index] = ip2;
		} else {
			PRINT_DEBUG(50, "%d - No more fake IP Addresses.\n", index);
		}
	}

}
