/**
 *  \file CompressionInfo.h
 *  \brief The compression properties of a PathInfo object.
*/

#ifndef COMPRESSION_INFO_H
#define COMPRESSION_INFO_H

// Compression Algorithms

/** Standard ZLIB compression algorithm */
#define COMPRESSION_ALGO_ZLIB       1

/** Unknown compression algo */
#define COMPRESSION_ALGO_UNKNOWN    -1

/**
  * This class represents the compression properties of a PathInfo.
  */
class CompressionInfo {

    /** The compression algorithm to be used */
    int algorithm;

    /** Compression Level - interpretation depends on the compression protocol */
    int compressionLevel;

public:

    CompressionInfo ();

    friend class PathInfoConfigFile;
};

#endif
