/**
 *  \file SecurityInfo.h
 *  \brief Declaration of the security properties of a path.
*/

#ifndef SECURITY_INFO_H
#define SECURITY_INFO_H

// Security Protocol Numbers

/** Custom SSL protocol with support for middle boxes */
#define SECURITY_PROTOCOL_CUSTOM_SSL    1

/** Standard SSL protocol */
#define SECURITY_PROTOCOL_SSL           2

/** UNKNOWN protocol */
#define SECURITY_PROTOCOL_UNKNOWN       -1

/**
  * This class encapsulates the security properties of a 
  * PathInfo.
  */
class SecurityInfo {

    /** 
      * What is the security protocol to be used?
      * SECURITY_PROTOCOL_CUSTOM_SSL, SECURITY_PROTOCOL_SSL ... 
     */
    int protocol;

public:

    SecurityInfo ();

    friend class PathInfoConfigFile;
    friend class PathInfo;
    friend class OCI;
	friend class OCIState;
};

#endif
