/**
 *  \file InetFns.h
 *  \brief Network address function declarations.
*/

#ifndef INETFNS_H
#define INETFNS_H 1

#ifndef _WIN32
	#include <netinet/in.h>
#else
extern "C" {
	#include "netwrap.h"
}
#endif

#ifdef __APPLE__
	#include <stdint.h>
#endif

#include "../common.h"

#define TRIVIAL_LOCAL_ADDR	"127.0.0.1"

/* Get address of local machine */
uint32_t name_to_addr(const char *);
uint32_t get_local_addr();
uint32_t getLocalAddress (bool *foundFlag);

bool convert_ipaddr_str2int (const char* ipAddrStr, ipaddr_n_t* ipAddrInt);
bool convert_ipaddr_int2str (ipaddr_n_t ipAddrInt, char* ipAddrStr);

#ifdef _WIN32
bool getHumanReadableInterfaceName (char *adapterName, char* humanReadableName, DWORD* humanReadableNameLen);
#endif

#endif
