/**
 *  \file StringTokenizer.h
 *  \brief Declaration of the StringTokenizer class.
*/

/*
 ***********************************************************************
 * Class: StringTokenizer                                              *
 * By Arash Partow - 2000                                              *
 * URL: http://www.partow.net/programming/stringtokenizer/index.html   *
 *                                                                     *
 * Copyright Notice:                                                   *
 * Free use of this library is permitted under the guidelines and      *
 * in accordance with the most current version of the Common Public    *
 * License.                                                            *
 * http://www.opensource.org/licenses/cpl.php                          *
 *                                                                     *
 ***********************************************************************
*/



#ifndef INCLUDE_STRINGTOKENIZER_H
#define INCLUDE_STRINGTOKENIZER_H


#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>

#ifdef _WIN32
#	include <winsock2.h>
#	include	<windows.h>
#endif

#include "../OCALA_Export.h"

using namespace std;

class StringTokenizer
{

   public:

    OCALA_LIB_EXPORT_IMPORT StringTokenizer(string str, string delim);
    OCALA_LIB_EXPORT_IMPORT ~StringTokenizer(){};

    OCALA_LIB_EXPORT_IMPORT int    countTokens();
    OCALA_LIB_EXPORT_IMPORT bool   hasMoreTokens();
    OCALA_LIB_EXPORT_IMPORT string nextToken();
    OCALA_LIB_EXPORT_IMPORT int    nextIntToken();
    OCALA_LIB_EXPORT_IMPORT long    nextLongToken();
    OCALA_LIB_EXPORT_IMPORT double nextFloatToken();
    OCALA_LIB_EXPORT_IMPORT string nextToken(string delim);
    OCALA_LIB_EXPORT_IMPORT string remainingString();
    OCALA_LIB_EXPORT_IMPORT string filterNextToken(string filterStr);

   private:

    string  tokenStr;
    string  delim;

};

#endif
