/**
 *  \file utilFunctions.h
 *  \brief Utility function declarations.
*/

#ifndef UTIL_FUNCTIONS_H
#define UTIL_FUNCTIONS_H 1

#include <stack>
using namespace std;

#include "../OCALA_Export.h"
#include "../fwint.h"

/**
  * This file contains some general utility function declarations.
  */

#ifndef __APPLE__
#define MIN(x, y) ((x) < (y) ? (x) : (y))

#define MAX(x, y) ((x) > (y) ? (x) : (y))
#endif

#include <string>
using namespace std;

OCALA_LIB_EXPORT_IMPORT string toLowerCase(string src);
OCALA_LIB_EXPORT_IMPORT struct in_addr get_my_addr(bool *);
OCALA_LIB_EXPORT_IMPORT bool isBlank (const char *);

OCALA_LIB_EXPORT_IMPORT void toLowerCase(const char *src, char *dst);

#ifndef _WIN32
	void strlwr(char *str);
#endif
 
OCALA_LIB_EXPORT_IMPORT void chomp (char *);
OCALA_LIB_EXPORT_IMPORT unsigned short in_cksum (unsigned short *addr, int len);

OCALA_LIB_EXPORT_IMPORT int isSuffix ( const char* masterStr, const char* suffix);
OCALA_LIB_EXPORT_IMPORT int isPrefix ( const char* masterStr, const char* prefix);
OCALA_LIB_EXPORT_IMPORT bool stripSuffix (char *str, const char *suffix) ;
OCALA_LIB_EXPORT_IMPORT void stripWS(char* str);

OCALA_LIB_EXPORT_IMPORT char *generateRandomStr (char *buf);

OCALA_LIB_EXPORT_IMPORT int strCountCh (const char *str, char ch);

OCALA_LIB_EXPORT_IMPORT bool isBigEndian ();
OCALA_LIB_EXPORT_IMPORT uint64_t hton64 (uint64_t num);
OCALA_LIB_EXPORT_IMPORT uint64_t ntoh64 (uint64_t num);

#ifdef _WIN32
OCALA_LIB_EXPORT_IMPORT LPCSTR GetErrorMsgStr (LPCSTR lpMsgBuf);
OCALA_LIB_EXPORT_IMPORT bool readRegValue (const char *regPath, const char* valName, char* valStr, DWORD* valStrLen);
OCALA_LIB_EXPORT_IMPORT BOOL MakeRegKeyAccessible (HKEY key, const char *keyName);
#endif

#endif
