/**
 * \file CleanRegistry.cpp
 * \brief This program cleans up the registry entrie created by OCALA.
 */
#include <windows.h>
#include <shlwapi.h>
#include <stdio.h>
#include "../../ocd/RegistryParams.h"

int main (int argc, char* argv[]) {

	// Open the Software Key
	HKEY keySoftware;
	HRESULT res = RegOpenKeyEx( HKEY_LOCAL_MACHINE,
							 "Software",
							 0, /* Reserved must be 0 */
							 KEY_ALL_ACCESS,
							 &keySoftware
						);

	if (res != ERROR_SUCCESS) {
		printf ("Unable to open the HKEY_LOCAL_MACHINE/Software key.\n");
		return -1;
	}
	
	res = SHDeleteKey ( keySoftware, REGISTRY_APP_NAME);
	if ( res != ERROR_SUCCESS) {
		printf ("Unable to delete HKEY_LOCAL_MACHINE/Software/%s.\n", REGISTRY_APP_NAME);
	}

	RegCloseKey (keySoftware);

	return 0;
}
