// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ProxyMonitorApp.h"
#include "ProxyService.h"
#include "MainFrm.h"
#include "OCDStatus.h"
#include "debug.h"
#include "DynamicItems.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CHAR* g_WindowClass;
extern ProxyMonitorApp theApp;

#ifndef SYSTEMTRAY_USEW2K
#define NIIF_WARNING 0
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(IDC_HIDE_ICON, OnUpdateHideIcon)
	ON_UPDATE_COMMAND_UI(IDC_SHOW_BALLOON, OnUpdateShowBalloon)
	ON_UPDATE_COMMAND_UI(IDC_MOVE_TO_RIGHT, OnUpdateMoveToRight)
	ON_UPDATE_COMMAND_UI(IDC_SHOW_ICON, OnUpdateShowIcon)
	ON_UPDATE_COMMAND_UI(IDC_SET_FOCUS, OnUpdateSetFocus)
	ON_UPDATE_COMMAND_UI(ID_DEMO_MAXIMISE, OnUpdateDemoMaximise)
	ON_UPDATE_COMMAND_UI(ID_DEMO_MINIMISE, OnUpdateDemoMinimise)
	ON_COMMAND(ID_START_PROXY_COLD, OnStartProxyCold)
	ON_COMMAND(ID_START_PROXY_UNCOLD, OnStartProxyUncold)
	ON_COMMAND(ID_STOP_PROXY, OnStopProxy)
	ON_UPDATE_COMMAND_UI(ID_STOP_PROXY, OnUpdateMenuItem)
	ON_UPDATE_COMMAND_UI(ID_START_PROXY_COLD, OnUpdateMenuItem)
	ON_UPDATE_COMMAND_UI(ID_START_PROXY_UNCOLD, OnUpdateMenuItem)
	ON_UPDATE_COMMAND_UI (ID_CONFIGURE_SECURE_CONNECTION, OnUpdateMenuItem)

	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE( ID_POPUP_DynCmd01, ID_POPUP_DynCmd01 + CDynamicItems::GetNbMaxItems(), OnExecuteDynamicMenu )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// register window class
        WNDCLASS        stWndClass;
        CString szClassName;
        szClassName  = _T(g_WindowClass);
        CString szWindowName;
        szWindowName = _T(g_WindowClass);

        stWndClass.style                        = CS_BYTEALIGNWINDOW;
        stWndClass.lpfnWndProc          = &AfxWndProc;
        stWndClass.cbClsExtra           = 0;
        stWndClass.cbWndExtra           = 0;
        stWndClass.hInstance            = AfxGetInstanceHandle();
        stWndClass.hIcon                        = NULL;
        stWndClass.hCursor                      = NULL;
        stWndClass.hbrBackground        = (HBRUSH)COLOR_BACKGROUND;
        stWndClass.lpszMenuName         = NULL;
        stWndClass.lpszClassName        = _T ("ProxyMonitorApp1");

        AfxRegisterClass(&stWndClass);

	  // make window
        CRect   rect(0, 0, 100, 100);

		Create(_T ("ProxyMonitorApp1"), szWindowName, WS_OVERLAPPEDWINDOW | WS_MINIMIZE, rect);

		lastStopProxyTime = 0;
		lastStartProxyTime = 0;
}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	
    HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));  // Icon to use
 
	// Create the tray icon
	if (!m_TrayIcon.Create(
                        NULL,                            // Let icon deal with its own messages
                        WM_ICON_NOTIFY,                  // Icon notify message to use
                        _T("OCALA Proxy Monitor - Right click for tasks"),  // tooltip
                        hIcon,
                        IDR_POPUP_MENU,                  // ID of tray icon
                        FALSE,
                        NULL,							// balloon tip
                        NULL,							// balloon title
                        NIIF_WARNING,                    // balloon icon
                        20 ))                            // balloon timeout
    {
		return -1;
    }


	m_TrayIcon.SetMenuDefaultItem(3, TRUE);
	
	m_TrayIcon.MinimiseToTray(this);

	// Start the timer which periodically refreshes the proxy status.
	m_ocdRefreshTimer = SetTimer(1, 2000 /* 2	seconds */, NULL /* handle the events by the CWnd */);



	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame/CSystemTray menu message handlers

void CMainFrame::OnUpdateShowIcon(CCmdUI* pCmdUI) 
{
    pCmdUI->Enable ( !m_TrayIcon.Visible() );
}

void CMainFrame::OnUpdateHideIcon(CCmdUI* pCmdUI) 
{
    pCmdUI->Enable ( m_TrayIcon.Visible() );
}

void CMainFrame::OnUpdateMoveToRight(CCmdUI* pCmdUI) 
{
    pCmdUI->Enable ( m_TrayIcon.Visible() );
}

void CMainFrame::OnUpdateShowBalloon(CCmdUI* pCmdUI) 
{
#ifdef SYSTEMTRAY_USEW2K
    pCmdUI->Enable ( m_TrayIcon.Visible() );
#else
    pCmdUI->Enable(FALSE);
#endif
}

void CMainFrame::OnUpdateSetFocus(CCmdUI* pCmdUI) 
{
#ifdef SYSTEMTRAY_USEW2K
    pCmdUI->Enable ( m_TrayIcon.Visible() );
#else
    pCmdUI->Enable(FALSE);
#endif
}

void CMainFrame::OnClose() 
{
    m_TrayIcon.RemoveIcon();	
	CFrameWnd::OnClose();
}

void CMainFrame::OnUpdateDemoMaximise(CCmdUI* pCmdUI) 
{
#ifdef _WIN32_WCE
    pCmdUI->Enable(FALSE);
#else
    pCmdUI->Enable(!IsIconic() && !IsWindowVisible());
#endif
}

void CMainFrame::OnUpdateDemoMinimise(CCmdUI* pCmdUI) 
{
#ifdef _WIN32_WCE
    pCmdUI->Enable(FALSE);
#else
    pCmdUI->Enable(!IsIconic() && IsWindowVisible());
#endif
}


/** This function must be called before any of My message handlers
 * which use the proxyService variable are invoked.
 */
void CMainFrame::SetProxyService (ProxyService* proxyService) {
	this->proxyService = proxyService;
}

// My Message Handlers
void CMainFrame::OnStartProxyCold () {
	
	lastStartProxyTime = time (NULL);
	proxyService->StartProxy (true /*coldStartFlag */);
}

void CMainFrame::OnStartProxyUncold () {
	lastStartProxyTime = time (NULL);
	proxyService->StartProxy (false /*coldStartFlag */);
}

void CMainFrame::OnStopProxy () {
	lastStopProxyTime = time (NULL);
	proxyService->StopProxy();
}


void CMainFrame::OnTimer(UINT nIDEvent) {

	
	//char tt[200];
	//sprintf (tt, "-->%d %p %x\n\n", AfxGetInstanceHandle(), AfxGetInstanceHandle(), AfxGetInstanceHandle());
	//PRINT_DEBUG1 (DEBUG_LEVEL_SUPER, "%s", tt);
	
	if (proxyService != NULL) {
		 DWORD proxyStatusCode;
		 string proxyStatusMsg;
		 list<OCDStatus *> ocdStatusList;
  		proxyService->RefreshProxyStatus (&proxyStatusCode, &proxyStatusMsg, &ocdStatusList);
		  interpretOCDStatusList (&ocdStatusList);
	}

   // Call base class handler.
   //CMDIFrameWnd::OnTimer(nIDEvent);
}

/**
 * Creates appropriate dynamic menu entries based on the OCDs in ocd Status list
 * and their status.
 */
void CMainFrame::interpretOCDStatusList (list<OCDStatus* >* ocdStatusList) {

#define DYN_MENU_FILE "OCALA_ProxyMonitor_dynamicMenu.txt"
	FILE* menuFD = fopen (DYN_MENU_FILE, "w");
	if (menuFD == NULL) {
		PRINT_INFO1 (INFO_LEVEL_WARNING,
			"Unable to open dynamic menu file " DYN_MENU_FILE " for writing: %s",
			strerror (errno)
		);
		return;
	}
	list<OCDStatus*>::iterator itr = ocdStatusList->begin();
	while (itr != ocdStatusList->end()) {
		OCDStatus* currOCDStatus = *itr;
		if (currOCDStatus->id == "rspTunnelOCD") {
			if (!proxyService->IsRunning() ||currOCDStatus->getStatusCode() == 0) {
				fputs ("ITEM OCALA Secure Connection - Inactive\n", menuFD);
			} else if (currOCDStatus->getStatusCode() == 1) {
				fputs ("ITEM OCALA Secure Connection - Active\n", menuFD);
			} else {
				fputs ("ITEM OCALA Secure Connection - Initializing\n", menuFD);
			}
			fputs ("\tCOMMENT \"OCALA Secure Connection Status\"\n", menuFD);
			fputs ("\tFUNCTION OCALA_Secure_Connection_status\n", menuFD);
			
			fputs ("ITEM OCALA Secure Connection - Configure\n", menuFD);
			fputs ("\tCOMMENT \"OCALA Secure Connection Configure\"\n", menuFD);
			fputs ("\tFUNCTION OCALA_Secure_Connection_configure\n", menuFD);
	
		} else if (currOCDStatus->id == "pli3") {
			if (!proxyService->IsRunning() || currOCDStatus->getStatusCode() == 0) {
				fputs ("ITEM NAT Server Access via i3 - Inactive\n", menuFD);
			} else if (currOCDStatus->getStatusCode() == 1){
				fputs ("ITEM NAT Server Access via i3 - Active\n", menuFD);
			} else {
				fputs ("ITEM NAT Server Access via i3 - Initializing\n", menuFD);
			}
			fputs ("\tCOMMENT \"NAT Server Access via i3 Status\"\n", menuFD);
			fputs ("\tFUNCTION NAT_Server_Access_status\n", menuFD);

			fputs ("ITEM NAT Server Access via i3 - Configure\n", menuFD);
			fputs ("\tCOMMENT \"NAT Server Access via i3 Configure\"\n", menuFD);
			fputs ("\tFUNCTION NAT_Server_Access_configure\n", menuFD);

		} else {
			char tmpBuf [1000];
			if (!proxyService->IsRunning() || currOCDStatus->getStatusCode() == 0) {
				sprintf (tmpBuf, "ITEM %s - INACTIVE\n", currOCDStatus->id.c_str());
			} else if (currOCDStatus->getStatusCode() == 1){
				sprintf (tmpBuf, "ITEM %s - ACTIVE\n", currOCDStatus->id.c_str());
			} else {
				sprintf (tmpBuf, "ITEM %s - INITIALIZING\n", currOCDStatus->id.c_str());
			}
			fputs (tmpBuf, menuFD);

			sprintf (tmpBuf, "\tCOMMENT \"%s\"\n", currOCDStatus->description.c_str());
			fputs (tmpBuf, menuFD);
			sprintf (tmpBuf, "\tFUNCTION %s_configure\n", currOCDStatus->id.c_str());
			fputs (tmpBuf, menuFD);

		}
	
		fputs ("SEPARATOR\n\n", menuFD);
		itr++;
	}

	fclose (menuFD);
	m_DynamicItems.readFromFile (DYN_MENU_FILE);
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
//	cs.lpszName = _T("ProxyMonitorApp");
//	cs.lpszClass = _T("ProxyMonitorApp");

    // Call the base-class version
    return CFrameWnd::PreCreateWindow(cs); 
}

BOOL CMainFrame::MyLoadFrame(UINT nIDResource, DWORD dwDefaultStyle,
	CWnd* pParentWnd, CCreateContext* pContext)
{
	// only do this once
//	ASSERT_VALID_IDR(nIDResource);
	ASSERT(m_nIDHelp == 0 || m_nIDHelp == nIDResource);

	m_nIDHelp = nIDResource;    // ID for help context (+HID_BASE_RESOURCE)

	CString strFullString;
	if (strFullString.LoadString(nIDResource))
		AfxExtractSubString(m_strTitle, strFullString, 0);    // first sub-string

//	VERIFY(AfxDeferRegisterClass(AFX_WNDFRAMEORVIEW_REG));

	// attempt to create the window
	//LPCTSTR lpszClass = GetIconWndClass(dwDefaultStyle, nIDResource);
	CString strTitle = m_strTitle;
	if (!Create(_T ("ProxyMonitorApp"), strTitle, dwDefaultStyle, rectDefault,
	  pParentWnd, MAKEINTRESOURCE(nIDResource), 0L, pContext))
	{
		return FALSE;   // will self destruct on failure normally
	}

	// save the default menu handle
	ASSERT(m_hWnd != NULL);
	m_hMenuDefault = ::GetMenu(m_hWnd);

	// load accelerator resource
	LoadAccelTable(MAKEINTRESOURCE(nIDResource));

	/*
	if (pContext == NULL)   // send initial update
		SendMessageToDescendants(WM_INITIALUPDATE, 0, 0, TRUE, TRUE);
*/
	return TRUE;
}

/** This function is called whenever a menu item is about to be drawn.
 *  It controls if the menu item should be enabled or not.
 */
void CMainFrame::OnUpdateMenuItem(CCmdUI* myMenuItem) {
	
	switch (myMenuItem->m_nID) {

		case ID_STOP_PROXY:
		{
			time_t tmpTime = time (NULL);
			if ((tmpTime - lastStopProxyTime) < 40 ) { //seconds
				CString tmpStr = "Proxy still stopping. Please Wait.";
				myMenuItem->Enable (false);
				myMenuItem->SetText (tmpStr);
			} else {
				CString tmpStr = "Stop Proxy";
				myMenuItem->Enable (proxyService->IsRunningAsService() || proxyService->IsRunningAsExec());
				myMenuItem->SetText (tmpStr);
			}
		}
		break;

		case ID_START_PROXY_COLD:
			if ( ! (proxyService->IsRunningAsService() || proxyService->IsRunningAsExec())) {
				time_t tmpTime = time (NULL);
				if ((tmpTime - lastStopProxyTime) < 40 ) { //seconds
					CString tmpStr = "Proxy still stopping. Please Wait.";
					myMenuItem->Enable (false);
					myMenuItem->SetText (tmpStr);

				} else if ((tmpTime - lastStartProxyTime) < 40 ) { //seconds
					CString tmpStr = "Proxy starting. Please Wait.";
					myMenuItem->Enable (false);
					myMenuItem->SetText (tmpStr);

				} else {
					CString tmpStr = "Start Proxy";
					myMenuItem->Enable (TRUE);
					myMenuItem->SetText (tmpStr);
				}

			} else {
				myMenuItem->Enable (FALSE);
			}
		break;

		case ID_START_PROXY_UNCOLD:
			if ( ! proxyService->IsRunningAsExec ()) {
				myMenuItem->Enable (!proxyService->IsRunning());
			} else {
				myMenuItem->Enable (FALSE);
			}
		break;
		
		case ID_CONFIGURE_SECURE_CONNECTION:
			if ( ! proxyService->IsRunningAsExec ()) {
		
				OCDStatus* rspOCDStatus = proxyService->getOCDStatus ("rspTunnelOCD");
				if (rspOCDStatus == NULL) {
					// There is no RSP OCD Status object available.
					// So there is no point having this menu item at all.
					CString tmpStr = "Secure Connection UNAVAILABLE.";
					myMenuItem->Enable (false);
					myMenuItem->SetText (tmpStr);
				} else {
					if (rspOCDStatus->getStatusCode() == 1 ) {
						// Currently active.
						CString tmpStr = "Secure Connection ON: Configure it";
						myMenuItem->SetText (tmpStr);
					} else if (rspOCDStatus->getStatusCode() == 0) {
						// Currently inactive
						CString tmpStr = "Secure Connection OFF: Turn ON and Configure it";
						myMenuItem->SetText (tmpStr);
					}
					myMenuItem->Enable (proxyService->IsRunning());
				}
			} else {
				myMenuItem->Enable (FALSE);
			}
		break;

		default:
			myMenuItem->Enable (TRUE);
	}
} 

/**
 * This method is called every time you click on a dynamic item in the menu
 */
void CMainFrame::OnExecuteDynamicMenu( UINT nID )
{


		string strItemFunc = 	m_DynamicItems.GetItemFunctionType(nID-ID_POPUP_DynCmd01);
		
		if (strItemFunc == "OCALA_SECURE_CONNECTION_STATUS") {
			ShowOCDStatusBox (string("rspTunnelOCD"));

		} else if (strItemFunc == "NAT_SERVER_ACCESS_STATUS") {
			ShowOCDStatusBox (string ("pli3"));
		} else if (strItemFunc == "NAT_SERVER_ACCESS_CONFIGURE") {
			theApp.OnConfigureNATServer ();
		} else if (strItemFunc == "OCALA_SECURE_CONNECTION_CONFIGURE") {
			theApp.OnConfigureSecureConnection ();
		}
}

/**
 * Shows the status message associated with the specified OC-D 
 * in a dialog box.
 */
void CMainFrame::ShowOCDStatusBox (string ocdId) {

	DWORD proxyStatusCode;
	string proxyStatusMsg;
	list<OCDStatus *> ocdStatusList;
	proxyService->RefreshProxyStatus (&proxyStatusCode, &proxyStatusMsg, &ocdStatusList);
			
	list<OCDStatus*>::iterator ocdItr = ocdStatusList.begin();
	while (ocdItr != ocdStatusList.end()) {
		
		OCDStatus* currOCDStatus = *ocdItr;
		if (currOCDStatus->id == ocdId) {
			char msgBuf[10000];
			if (proxyService->IsRunning()) {
			sprintf (msgBuf, 
					"%s - ACTIVE\n"
					"%s\n\n"
					"%s\n"
					,
					currOCDStatus->id.c_str(), 
					currOCDStatus->description.c_str(),
					currOCDStatus->statusMsg.c_str()
				);

			} else {
				sprintf (msgBuf, 
					"%s - INACTIVE\n"
					"%s\n\n"
					,
					currOCDStatus->id.c_str(),
					currOCDStatus->description.c_str()
				);

			}

			AfxMessageBox (msgBuf, MB_OK|MB_ICONINFORMATION);
			return;
		}
		ocdItr++;
	}
}