// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "DynamicItems.h" 

#if !defined(AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_)
#define AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define	WM_ICON_NOTIFY			WM_APP+10

#include <list>
using namespace std;

#include "SystemTray.h"

class ProxyService;
class OCDStatus;

class CMainFrame : public CFrameWnd
{

	ProxyService *proxyService;

	UINT_PTR m_ocdRefreshTimer;

	/** When was the proxy stop menu item last chosen. */
	time_t lastStopProxyTime;
	time_t lastStartProxyTime;

	/** Dynamic menu items. Ref: http://www.codeproject.com/menu/dynitems.asp */
	CDynamicItems m_DynamicItems;

	void interpretOCDStatusList (list<OCDStatus* >* ocdStatusList);

public:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	CSystemTray m_TrayIcon;

// Operations
public:

	CDynamicItems*	getDynamicMenu(){ return &m_DynamicItems; };

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	//}}AFX_VIRTUAL

// Implementation 
public:
	virtual ~CMainFrame();
	void SetProxyService (ProxyService *);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	void ShowOCDStatusBox (string ocdId);

	virtual BOOL MyLoadFrame(
			UINT nIDResource,
			DWORD dwDefaultStyle = WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
			CWnd* pParentWnd = NULL,
			CCreateContext* pContext = NULL 
		);

	BOOL PreCreateWindow(CREATESTRUCT& cs);

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClose();
	afx_msg void OnUpdateHideIcon(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowBalloon(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMoveToRight(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowIcon(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSetFocus(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDemoMaximise(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDemoMinimise(CCmdUI* pCmdUI);

	// My Message Handler declarations
	afx_msg void OnStartProxyCold();
	afx_msg void OnStartProxyUncold();
	afx_msg void OnStopProxy();
	afx_msg void OnUpdateMenuItem(CCmdUI* myMenuItem);

	//}}AFX_MSG
	afx_msg void OnExecuteDynamicMenu( UINT nID );

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__E2B26DD7_886E_11D1_9BF5_00A0243D1382__INCLUDED_)
