#ifndef OCD_STATUS_H
#define OCD_STATUS_H

#include <string>
#include <map>
using namespace std;

#include <afxwin.h>

#include "SystemTray.h"
#include "MainFrm.h"

/** 
 * This class just encapsulates the various properties about
 * a particular OCD which is read from its registry entry.
 */
class OCDStatus {

	string id;
	string description;
	string type;
	string statusMsg;
	DWORD statusCode;
	
	string iconList;
	string currentIconName;

	// TODO: MEMORY LEAK: This dummy variable is needed.  else currentIconName 
	// gets filled with junk when you try to assign something to it.
	// FIX!!!
	string dummy;

	/** Pointer to the System Tray Icon representing this OCD.
	 */
	CSystemTray m_TrayIcon;

	/** Has the system tray icon been initialized correctly. */
	BOOL m_iconInitFlag;

	string getToolTipText();

	/** List of loaded HICONs to the name of the file containing the icon.
	 * Just the filename, not the entire path.
	 */
	map<string, HICON> map_Icon_name;

	void loadIcons();
	HICON getCurrentIcon();

public:
	OCDStatus (string id, string type, string description, string statusMsg, DWORD statusCode, string iconList, string currentIcon);
	void update (string description, string statusMsg, DWORD statusCode, string currIconList, string currentIcon, bool redrawIconFlag);
	void updateIcon();
	void showBalloon(string balloonMsg);

	DWORD getStatusCode () {
		return statusCode;
	}

	friend class ProxyService;
	friend class CMainFrame;
};
#endif // OCD_STATUS