/**
 *  \file ProxyMonitorApp.cpp
 *  \brief This is the main class of the proxy monitor application.
 *  Execution starts here.
 */

#include "stdafx.h"
#include "ProxyMonitorApp.h"
#include "ProxyService.h"

#include "MainFrm.h"

#include "debug.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CHAR* g_WindowClass;

/////////////////////////////////////////////////////////////////////////////
// ProxyMonitorApp

BEGIN_MESSAGE_MAP(ProxyMonitorApp, CWinApp)
	//{{AFX_MSG_MAP(ProxyMonitorApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_CONFIGURE_SECURE_CONNECTION, OnConfigureSecureConnection)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


ProxyMonitorApp::ProxyMonitorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

ProxyMonitorApp::~ProxyMonitorApp() {
	delete proxyService;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only ProxyMonitorApp object
 
ProxyMonitorApp theApp;

/////////////////////////////////////////////////////////////////////////////
// ProxyMonitorApp initialization

BOOL ProxyMonitorApp::InitInstance()
{
	// Standard initialization
 
	g_WindowClass = "ProxyMonitorApp1";
	
	debugFD = fopen ("debug_ProxyMonitorApp.txt", "w");
	if (debugFD == NULL) {
		MessageBeep (MB_ICONEXCLAMATION);
		exit (-1);
	}

	PRINT_DEBUG0 ( DEBUG_LEVEL_SUPER,
					"Starting ProxyMonitor.\n"
					);

	/*
		 WNDCLASS wndcls;

    memset(&wndcls, 0, sizeof(WNDCLASS));   // start with NULL
                                            // defaults

	wndcls.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;

    //you can specify your own window procedure
    wndcls.lpfnWndProc = ::DefWindowProc;
    wndcls.hInstance = AfxGetInstanceHandle();

    wndcls.hIcon = NULL;
    wndcls.hCursor = NULL;
    wndcls.hbrBackground = NULL;
    wndcls.lpszMenuName = NULL;

    // Specify your own class name for using FindWindow later
    wndcls.lpszClassName = g_WindowClass;

    // Register the new class and exit if it fails
    if(!RegisterClass(&wndcls))
    {
       TRACE("Class Registration Failed\n");
       return FALSE; 
    }
*/



	CMainFrame* pMainFrame = new CMainFrame;
	
	/*if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	*/

	m_pMainWnd = pMainFrame;
 
	m_pMainWnd->ShowWindow(1);

	// For debugging (or something...)
	 //pMainFrame->ActivateFrame();

	 DWORD proxyStatusCode;
	 string proxyStatusMsg;
	 list<OCDStatus *> ocdStatusList;
	 
	 proxyService = new ProxyService();
	 proxyService->RefreshProxyStatus (&proxyStatusCode, &proxyStatusMsg, &ocdStatusList);

	 pMainFrame->SetProxyService (proxyService);
	
	 

	

	 return TRUE;

}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void ProxyMonitorApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void ProxyMonitorApp::OnConfigureSecureConnection () {
	LaunchProcess ("configureOCALA_secureconnection.bat");
}
void ProxyMonitorApp::OnConfigureNATServer () {
	LaunchProcess ("configureOCALA_NATServer.bat");
}

void ProxyMonitorApp::LaunchProcess (const char *processName) {

	STARTUPINFO si;
    PROCESS_INFORMATION pi;
    LPTSTR szCmdline=_tcsdup(TEXT(processName));

    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );

    // Start the child process. 
    if( !CreateProcess( NULL,   // No module name (use command line)
        szCmdline,      // Command line
        NULL,           // Process handle not inheritable
        NULL,           // Thread handle not inheritable
        FALSE,          // Set handle inheritance to FALSE
        0,              // No creation flags
        NULL,           // Use parent's environment block
        NULL,           // Use parent's starting directory 
        &si,            // Pointer to STARTUPINFO structure
        &pi )           // Pointer to PROCESS_INFORMATION structure
    ) 
    {
        printf( "CreateProcess failed (%d).\n", GetLastError() );
        return;
    }

    // Wait until child process exits.
    WaitForSingleObject( pi.hProcess, INFINITE );

    // Close process and thread handles. 
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );
}

