#ifndef PROXY_SERVICE_H
#define PROXY_SERVICE_H 1

#include "resource.h"

#include <list>
#include <map>
#include <string>
using namespace std;

class OCDStatus;

/** Number of milliseconds to wait for completion of any service
 * operation like start, stop.
 */
#define SERVICE_OP_TIMEOUT 10000

class ProxyService {
	/** Map of ocdID->OCDStatus objects.
	*/
	map<string, OCDStatus*> map_OCDStatus_id;

	OCDStatus* getOCDStatus (string id);
	bool addOCDStatus (OCDStatus*);

	void blankOCDStatus();

public:

	ProxyService();
	~ProxyService();
	void cleanUp();

	BOOL StartProxy (BOOL coldStartFlag);
	BOOL StopProxy ();
	BOOL IsRunning();
	BOOL IsRunningStatusCode ();
	BOOL IsRunningAsService ();
	BOOL IsRunningAsExec ();

	BOOL RefreshProxyStatus (
					 DWORD* proxyStatusCode, 
					 string* proxyStatusMsg, 
					 list<OCDStatus*>* ocdStatusList);

	friend class CMainFrame;
};

#endif