#ifndef _WIN32
#	include <sys/types.h>
#	include <sys/socket.h>
#	include <netinet/in.h>
#	include <arpa/inet.h>
#	include <netdb.h>
#	include <errno.h>
#endif

extern "C" {
#	include "netwrap.h"
}


#include "netwrap.h"
#include "RSPDNSReplyCallback.h"
#include "RSPServerFinder.h"
#include "RSPTunnelOCD_debug.h"


/**
  * @param domain The domain for which the DNS request was made.
  * @param rspServerFinder Pointer to RSPDNSReplyCallback which created this callback object.
 */
RSPDNSReplyCallback* RSPDNSReplyCallback::create (string domain, RSPServerFinder* rspServerFinder) {
    
    return new RSPDNSReplyCallback (domain, rspServerFinder);

}

RSPDNSReplyCallback::RSPDNSReplyCallback (string domain, RSPServerFinder* rspServerFinder) {
    this->domain = domain;
    this->rspServerFinder = rspServerFinder;
}
    
void RSPDNSReplyCallback::receivedLegacyDNSReply(uint32_t resolvedIP) {

    rspServerFinder->addMapping (domain, resolvedIP);

    // We no longer need this callback
    delete (this);
}
    
