/**
 *  \file RSPTunnelOCDStateInfo.h
 *  \brief OCD state info associated with the sample ocd.
 */
#ifndef RSPTunnelOCD_STATE_INFO
#define RSPTunnelOCD_STATE_INFO 1

#ifndef _WIN32
#	include <sys/types.h>
#	include <sys/socket.h>
#else
#	include "netwrap.h"
#endif

#include "OCD_include.h"

class RSPTunnelOCD;



class RSPTunnelOCDStateInfo:public OCDStateInfo {
    
    /**
      * The IP address and port number of the remote end point (network byte order).
      * This is the way RSPTunnelOCD identifies a tunnel.
      * In i3, the i3 private trigger ids play the role of a unique identifier.
      */
    struct in_addr remoteAddress;
    uint16_t remotePort;

    void fakeSetupSuccess();

    /** Timer event to make setup success notification asynchronous when the OC-D is already ready.
     */
	TimerEvent* fakeSetupSuccessTimer;
	
public:

    RSPTunnelOCDStateInfo(OCDHandle myHandle, OCI* oci, RSPTunnelOCD *varRSPTunnelOCD, string endPointName);
	~RSPTunnelOCDStateInfo();

	void setFakeSetupTimer ();
    friend class RSPTunnelOCD;
    friend class RSPTunnelOCDContext;
};

#endif
