#ifndef RSPTunnelOCD_DEBUG_FNS_H
#define RSPTunnelOCD_DEBUG_FNS_H 1


#define RSPTunnelOCD_DEBUG


#	ifndef RSPTunnelOCD_PRINT_DEBUG
#		if !defined(_WIN32) || defined(__CYGWIN__)
#			ifdef DEBUG_ENABLED
			/**
   			 * This macro is used to print debugging information. 
			 * The message is printed only if the current debugging level is
			 * greater than that of the level specified in the macro call.
			 */

#				define RSPTunnelOCD_PRINT_DEBUG(debugLevel, msg, ... )  if(debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) { printf("[Line:%d in file:%s] ", __LINE__, __FILE__); printf(msg, ##__VA_ARGS__);}

#			else 

#				define RSPTunnelOCD_PRINT_DEBUG(debugLevel, msg, ... ) 

#			endif //DEBUG_ENABLED

#			define RSPTunnelOCD_PRINT_DEBUG0	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG1	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG2	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG3	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG4	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG5	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG6	RSPTunnelOCD_PRINT_DEBUG
#			define RSPTunnelOCD_PRINT_DEBUG7	RSPTunnelOCD_PRINT_DEBUG

#		else
		// stg: the MS compiler will support variadic macros only from version 7 on. Until then, we will have to live with warnings about too few arguments to this macro
		#define RSPTunnelOCD_PRINT_DEBUG0(debugLevel, msg) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG1(debugLevel, msg, arg1) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG2(debugLevel, msg, arg1, arg2) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG3(debugLevel, msg, arg1, arg2, arg3) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG4(debugLevel, msg, arg1, arg2, arg3, arg4) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG5(debugLevel, msg, arg1, arg2, arg3, arg4, arg5) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG6(debugLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6);fflush(varRSPTunnelOCDDebugFD);}
		#define RSPTunnelOCD_PRINT_DEBUG7(debugLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7) if (debugLevel <= RSPTunnelOCD_CURRENT_DEBUG_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7);fflush(varRSPTunnelOCDDebugFD);}
		//#define RSPTunnelOCD_PRINT_DEBUG(debugLevel, msg)
#endif
#endif  //RSPTunnelOCD_PRINT_DEBUG

/**
  * This macro is used to print messages irrespective of debug level.
  * These are messages are not for debugging, but for giving information
  * to the user.
  */
#	ifndef RSPTunnelOCD_PRINT_INFO
#		if !defined(_WIN32) || defined(__CYGWIN__)
#			define RSPTunnelOCD_PRINT_INFO(infoLevel, msg, ...) if(infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) printf(msg, ##__VA_ARGS__)

#			define RSPTunnelOCD_PRINT_INFO0	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO1	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO2	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO3	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO4	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO5	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO6	RSPTunnelOCD_PRINT_INFO
#			define RSPTunnelOCD_PRINT_INFO7	RSPTunnelOCD_PRINT_INFO

#		else
			// stg: the MS compiler will support variadic macros only from version 7 on. Until then, we will have to live with warnings about too few arguments to this macro
//#			define RSPTunnelOCD_PRINT_INFO(infoLevel, msg)
#			define RSPTunnelOCD_PRINT_INFO0(infoLevel, msg) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO1(infoLevel, msg, arg1) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO2(infoLevel, msg, arg1, arg2) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO3(infoLevel, msg, arg1, arg2, arg3) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO4(infoLevel, msg, arg1, arg2, arg3, arg4) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO5(infoLevel, msg, arg1, arg2, arg3, arg4, arg5) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO6(infoLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6);fflush(varRSPTunnelOCDDebugFD);}
#			define RSPTunnelOCD_PRINT_INFO7(infoLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7) if (infoLevel <= RSPTunnelOCD_CURRENT_INFO_LEVEL) {fprintf (varRSPTunnelOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7);fflush(varRSPTunnelOCDDebugFD);}
#		endif
#endif //RSPTunnelOCD_PRINT_INFO


#endif
