#!/usr/bin/perl
# This script creates the specified myNames.xml file with the specified name.
use strict;
use Sys::Hostname;

    
my $numArgs = $#ARGV + 1;
if ($numArgs < 2) {
    
    die "Usage: ./setupMyNames.pl <path to myNames.xml> <name>\n"; 
}

my $targetFile = $ARGV[0];
my $targetName = $ARGV[1];

open TMPFD, ">$targetFile" || die "Unable to open $targetFile for writing.\n";
print TMPFD <<END
<?xml version="1.0"?>

<MyNameList>
	<MyName
		name="$targetName"
		ocdId="pli3"
		active="true"
		i3TriggerType="public"
	/>

</MyNameList>

END
;
close TMPFD;
