/** 
 *  Hip OCD - HIP-i3 proxy implementation
 *  Andrei Gurtov, HIIT
 *  July 2005
 *  Licensed under GPL v2
 *
 *  Based on SampleOCD by Dilip Joseph
 */
#ifndef HIP_OCD_H
#define HIP_OCD_H 1

#define HIP_PORTNO 5643
#define SET_KEY "/usr/local/sbin/setkey -f /tmp/hipocd"

#include "OCD_include.h"

#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>

#include <vector>
#include <list>
#include <map>

using namespace std;


class HipOCDStateInfo;
class OCI;

/**
  * This class encapsulates a sample OCD.
  * This OCD is meant to be a reference for incorporating a new overlay into OCALA.
  * It does not illustrate all the features of OCALA (for example, middleboxes).
  * For a more detailed example, please look at the implementation of the I3 OCD module.
  */
class HipOCD : public OCD {
      // OCD specific state information
	int sockFD;
public:
    HipOCD (string type, string id, 
                    string desc, string fileName, 
                    string urlSuffixes, bool handleLegacyURLs
                );
    HipOCD (OCD *);

    virtual void init(Proxy*, OCI*, bool recoverFromCrash );

    virtual char* toString(char *tmpStr);
    //int getStatus();
    //void recoverRecord (char *);
    virtual void initMyNames ();
    


    virtual void send ( OCDHandle handle, char* data, int dataLen);
    virtual OCDHandle setup (
                const string endPointName, 
                int endPointNameType,
                char *optionBlocks, 
                int optionLen,
                OCIHandle ociHandle,
                OCI* oci );

private:
    virtual void receivedPacketFromOverlay();

    friend class HipOCDStateInfo;
};

#endif
