/**
 *  \file I3Key.h
 *  \brief Represents an I3 key object.  Wraparound the original i3 Key.
 */
#ifndef I3_KEY_H
#define I3_KEY_H 1

#include <string>
#include "i3.h"


#define KEY_LEN 16

/**
  * This class encapsulates an I3 Key
  */
class I3Key {
public:
    Key key;
    std::string keyStr;

    I3Key();
    I3Key(std::string keyStr);
    
    char* I3Key::toString(char *tmpStr);
    
    static void convert_str_to_hex(char* source,Key* k);
    static void setRandomKey (Key *key) ;
};

#endif
