#!/usr/bin/perl

use strict 'vars';
package main;

use Getopt::Std;
use Cwd;

use vars qw($opt_d $opt_p $opt_u);

#get command line options
getopts('d:u:p:');
if ($opt_d eq "" || $opt_p eq "") {
    die "Usage: start-i3-server.pl -d <conf_dir> -u <username> -p <path>\n";
}
if ($opt_u eq "") {
    $opt_u = "ucb6";
}

chdir ($opt_d) || die "Cannot change to conf directory\n";
opendir (CONF_DIR, ".") || die "Cannot open conf directory\n";

my $filename, my @arr, my $cmd;
while ($filename = readdir(CONF_DIR)) {
    if ($filename =~ "cfg") {
	@arr = split(/_/, $filename);
	print "Starting i3 on host $arr[1] at port $arr[2]\n";
	$cmd = "cd ~/$opt_p; ./i3_server $filename $arr[2] &";
	system($cmd);
	print "\n";
	sleep(5);
    }
}

close CONF_DIR;
