# Compile the ProxyConfig GUI
which javac 2>/dev/null 1>/dev/null
if [ $? -eq 0 ]
then
    cd OCALA/config_gui
    # save a copy of the precompiled ProxyConfig.jar, just in case compilation fails.
    if [ -f ProxyConfig.jar ]
    then
        cp ProxyConfig.jar ProxyConfig.jar.precompiled > ../../quickStart.log 2>&1
    fi
    
    echo "Compiling JAVA ProxyConfig GUI."
    ./createJar.sh >> ../../quickStart.log 2>&1
    cd ../..
    if [ ! -f OCALA/config_gui/ProxyConfig.jar ]
    then
        echo "Compilation of JAVA ProxyConfig GUI FAILED."
        if [ -f OCALA/config_gui/ProxyConfig.jar.precompiled ] 
        then
            echo "Using precompiled ProxyConfig.jar."
            cp OCALA/config_gui/ProxyConfig.jar.precompiled OCALA/config_gui/ProxyConfig.jar > quickStart.log 2>&1
            cp OCALA/config_gui/ProxyConfig.jar.precompiled OCALA/generic_proxy/ProxyConfig.jar > quickStart.log 2>&1
        fi
    else
        echo "Compilation of JAVA ProxyConfig GUI SUCCEEDED."
        cp OCALA/config_gui/ProxyConfig.jar OCALA/generic_proxy/ProxyConfig.jar > quickStart.log 2>&1
    fi
else 
    echo "javac not found.  Not compiling Java ProxyConfig GUI."
fi

# Copy the configureOCALA launch scripts
cp OCALA/config_gui/configureOCALA.sh OCALA/generic_proxy

echo


