#include <sys/types.h>
#include <sys/time.h>

/*
 * The usual:  Return the number of nanoseconds between 'now' and
 *             'prev'
 */

long timediff(const struct timeval *time_now,
	      const struct timeval *time_prev)
{
        long usecs_now;
        
        if (time_prev->tv_sec == 0 &&
            time_prev->tv_usec == 0) {
                return 0;
        }
        
        usecs_now = (time_now->tv_sec - time_prev->tv_sec) * 1000000;
        usecs_now += time_now->tv_usec;

        return usecs_now - time_prev->tv_usec;
}

void tv_add(struct timeval *to, unsigned long musec)
{
    to->tv_sec += musec / 1000000;
    to->tv_usec += musec % 1000000;
    if (to->tv_usec > 1000000) {
	to->tv_sec += to->tv_usec / 1000000;
	to->tv_usec %= 1000000;
    }
}
