#ifndef _MESH_PROTOCOL_H_
#define _MESH_PROTOCOL_H_

#include "ron.h"
#include "forw.h"
#include "scheduler.h"
#include "flowid.h"

namespace RON {
#define NUMSEQS 10
class seq_store {
public:
    seq_store() { nextseq = 0; }
    u_int32_t seqs[NUMSEQS];
    int nextseq;
    void incr() { nextseq++;  if (nextseq >= NUMSEQS) nextseq = 0; }
};

class mesh_protocol : public Plumber {
public:
    mesh_protocol() { }
    virtual ~mesh_protocol() { }
    // recv is for packets received from the network;
    // here we do duplicate suppression and whatnot.
    // To TRANSMIT via the mesh, use 'transmit'.
    // this interface needs some thought.  Just like flooding does.
    virtual int recv(pkt *packet, node *mynode, int via_ron);
    virtual int transmit(pkt *packet, node *mynode, int via_ron);
    int check_cache(pkt *packet);
    int add_to_cache(pkt *packet);
    void configure(Scheduler *s, forw *f);

    /* (SAR) Will need to be overwritten in NS emulation */
    virtual long int random(void) { return ::random(); }
private:
    forw *myforw;
    Scheduler *sched;
    /* XXX:  Need a way to age these!!  Otherwise we'll grow
     * without bound on the number of flows we see.  Bad. */
    map<flowid, seq_store> in_cache;
    map<flowid, u_int32_t> out_cache;
    u_int32_t get_next_seqno(pkt *packet);
};

}

#endif /* _MESH_PROTOCOL_H_ */
