#ifndef _NODE_H_
#define _NODE_H_

#include "ron.h"
#include <string>
#include <arpa/inet.h>

using namespace std;

namespace RON {

class node {
public:
    node() {
	node_port = htons(DEFAULT_RON_FORWARDER_PORT);
	node_addr.s_addr = 0;
    }

    node(node const& b)	{
	node_port = b.node_port;
	node_addr.s_addr = b.node_addr.s_addr;
    }


    node(struct in_addr newdst) {
	node_port = htons(DEFAULT_RON_FORWARDER_PORT);
	node_addr = newdst;
    }

    /* Note that the port is in network byte order */
    node(struct in_addr newdst, u_int16_t newport) {
	node_port = newport;
	node_addr = newdst;
    }

    node& operator=(const node &b) {
	node_addr = b.node_addr;
	node_port = b.node_port;
	return *this;
    }

    int operator==(const node &b) const {
	return ((node_addr.s_addr == b.node_addr.s_addr) &&
		(node_port == b.node_port));
    }

    int operator<(const node &b) const {
	if (node_addr.s_addr == b.node_addr.s_addr) {
	    return (node_port < b.node_port);
	} else {
	    return (node_addr.s_addr < b.node_addr.s_addr);
	}
    }

    string to_string() const {
	char mystring[128];
	bzero(mystring, sizeof(mystring));
	sprintf(mystring, "%s:%d", inet_ntoa(node_addr),
		ntohs(node_port));
	string s1(mystring);
	return s1;
    }

    int is_null() { return (node_addr.s_addr == 0); }
    
    int get_port() const { return node_port; }
    
    struct in_addr node_addr;
    u_int16_t node_port;                    /* Network byte order */
};

}

#endif /* _NODE_H_ */
