#ifndef _STATIC_MEMBERSHIP_H_
#define _STATIC_MEMBERSHIP_H_

#include <stdio.h>

#include "ron.h"
#include "membership.h"

namespace RON {

class static_membership : public membership {
public:
    void configure(Scheduler *s, forw *f);
    static_membership() { infilename = NULL; init(); }
    static_membership(char *filename) { infilename = filename; init(); }
    virtual ~static_membership() { ; }

    int reload();
    int last_changed() { return 0; }

    void init();
    void dump(FILE *out);
    int recv(pkt *mypkt, node *, int via_ron);

    list<node> *peers() {
	return &peerlist;
    }
private:
    Scheduler *sched;
    list<node> peerlist;
    char *infilename;
};

}

#endif /* _STATIC_MEMBERSHIP_H_ */
