#include "ronsys.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdarg.h>
#include <ctype.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <sys/time.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <net/if.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <string.h>
#include "rondebug.h"
#include "forw.h"
#include "ron.h"
#include "ronlib.h"
#include "membership.h"

#include "ip_conduit.h"
using namespace RON;

void IPDUMP(struct ip *ip) {
    fprintf(stderr,
	    "IP dump:\n"
	    "  version:  %d\n"
	    "  HL:       %d\n"
	    "  TOS:      %d\n"
	    "  LEN:      %d\n"
	    "  ID:       %d\n"
	    "  Offset:   %d\n"
	    "  Protocol: %d\n"
	    "  Checksum: %d\n"
	    "  TTL:      %d\n"
	    "  Src:      %s\n",
	    ip->ip_v,
	    ip->ip_hl,
	    ip->ip_tos,
	    ntohs(ip->ip_len),
	    ntohs(ip->ip_id),
	    ntohs(ip->ip_off),
	    ip->ip_p,
	    ntohs(ip->ip_sum),
	    ip->ip_ttl,
	    inet_ntoa(ip->ip_src));
    fprintf(stderr,
	    "  Dst:      %s\n",
	    inet_ntoa(ip->ip_dst));
}

int main() {
    int insock = create_divert_socket(9696);
    if (insock == -1) {
	perror("divert socket");
	exit(-1);
    }

    int outsock = raw_socket();
    if (outsock == -1) {
	perror("raw socket");
	exit(-1);
    }

    char buf[1600];
    while (1) {
	struct sockaddr_in in;
	unsigned int inlen = sizeof(in);
	int nbytes = recvfrom(insock, buf, sizeof(buf),
			      0, (struct sockaddr *)&in, &inlen);
	IPDUMP((struct ip *)buf);
	sendto(insock, buf, nbytes, 0, (struct sockaddr *)&in, inlen);
    }
}
