#ifndef _FLOOD_PROTOCOL_H_
#define _FLOOD_PROTOCOL_H_

#include "ron.h"
#include "forw.h"
#include "scheduler.h"

namespace RON {

class flood_protocol : public Plumber {
public:
    flood_protocol() { current_cache = 1; }
    virtual int recv(pkt *packet, node *mynode, int via_ron);
    virtual ~flood_protocol() { }
    virtual pkt *encapsulate(pkt *packet);
    int check_cache(pkt *packet);
    int add_to_cache(pkt *packet);
    void configure(Scheduler *s, forw *f);

    /* (SAR) Will need to be overwritten in NS emulation */
    virtual long int random(void)
	{
	    return ::random();
	}
private:
    forw *myforw;
    Scheduler *sched;
    static const unsigned int max_cache_size = 10000;
    map<u_int64_t, u_int32_t> cache1;
    map<u_int64_t, u_int32_t> cache2;
    int current_cache;
};

}

#endif /* _FLOOD_PROTOCOL_H_ */
