#ifndef _MESH_TESTER_H_
#define _MESH_TESTER_H_

#include "ron.h"
#include "forw.h"
#include "scheduler.h"
#include "flowid.h"

namespace RON {
#define NUMSEQS 10
#define PCACHESIZE 2000
class mt_seq_store {
public:
    mt_seq_store() { nextseq = 0; }
    u_int32_t seqs[NUMSEQS];
    int nextseq;
    void incr() { nextseq++;  if (nextseq >= NUMSEQS) nextseq = 0; }
};

class mesh_tester : public Plumber, time_callable {
public:
    mesh_tester() { devrand = -1; randinit = 0; }
    virtual ~mesh_tester() { }
    // recv is for packets received from the network;
    // here we do duplicate suppression and whatnot.
    // To TRANSMIT via the mesh, use 'transmit'.
    // this interface needs some thought.  Just like flooding does.
    virtual int recv(pkt *packet, node *mynode, int via_ron);
    virtual int transmit(pkt *packet, node *mynode, int via_ron);
    int check_cache(pkt *packet);
    int add_to_cache(pkt *packet);
    void configure(Scheduler *s, forw *f);
    virtual int timer_callback(void *data);

    /* (SAR) Will need to be overwritten in NS emulation */
    virtual long int random(void) { return ::random(); }
    void get_random(u_int64_t *q);
private:
    forw *myforw;
    Scheduler *sched;
    /* XXX:  Need a way to age these!!  Otherwise we'll grow
     * without bound on the number of flows we see.  Bad. */
    map<u_int64_t, u_int32_t> cache1;
    map<u_int64_t, u_int32_t> cache2;
    int current_cache;
    node *pick_random_node(node *skip);
    int send_ping(node *dst, int probetype, int type, u_int64_t id);
    int devrand;
    int randinit;
};

}

#endif /* _MESH_TESTER_H_ */
