#include "plumber.h"
#include "rondebug.h"
#include "forw.h"
#include "ron.h"
#include "ronlib.h"

#include "ron.h"
#include "packet.h"

namespace RON {

typedef struct {
    uint32_t num;
    char *desc;
} debug_descriptor;
    
debug_descriptor debug_packet_types[] = { {0x00000000, "DATA"},
					  {0x00000001, "ROUTING"},
					  {0x00000002, "PING"},
					  {0x00000003, "FLOOD"},
					  {0x00000004, "MEMBERSHIP"},
					  {0x00000005, "MAYBEDOWN"},
					  {0x00000006, "TEST"},
					  {0xFFFFFFFF, ""}};    

void describe_pkt(pkt *p)
{
    int i;
    char cont1[16], cont2[16];
    
    DPRINTF(DEBUG_PACKETS, "+----------------------------+\n");
    DPRINTF(DEBUG_PACKETS, " Packet ver %2d hlim %3d\n", p->get_version(), p->get_hlim());

    for (i=0;;i++)
	{
	    if (debug_packet_types[i].num == p->get_type())
		{
		    DPRINTF(DEBUG_PACKETS, " Type [ %s ]\n", debug_packet_types[i].desc);
		    break;
		}
	    else if (debug_packet_types[i].num == 0xFFFFFFFF)
		{
		    DPRINTF(DEBUG_PACKETS, " Unknown packet type %d \n", p->get_type());
		    break;
		}
	}

    DPRINTF(DEBUG_PACKETS, " Size <%d> FlowID <%d>\n", p->get_size(), p->get_flowid()); 
    strcpy(cont1, inet_ntoa(p->ron_hdr()->src_addr));
    strcpy(cont2, inet_ntoa(p->ron_hdr()->dst_addr));
	   
    DPRINTF(DEBUG_PACKETS, " From <%s:%d> To <%s:%d>\n", cont1, p->ron_hdr()->src_port,
	   cont2, p->ron_hdr()->dst_port);
	  
    DPRINTF(DEBUG_PACKETS, "+----------------------------+\n\n");

}

}
