#include "static_membership.h"
#include "rondebug.h"
#include "ronlib.h"

using namespace RON;

void
static_membership::configure(Scheduler *s, forw *f) {
    sched = s;
    myforw = f;
    // Unnecessary, but.. 
    f->register_type(RON_MEMBERSHIP, this, NULL);
    DPRINTF(DEBUG_INIT|DEBUG_MEMBERSHIP,
	    "static_membership::configure with forw %p\n", f);
}

void
static_membership::init()
{
    FILE *infile;
    char inbuf[256];
    char *fname;

    peerlist.clear();

    fname = infilename;

    if (!fname) {
	fname = getenv("PEERS");
	if (!fname) {
	    fname = "peers.txt";
	}
    }

    infile = fopen(fname, "r");
    if (!infile) {
	DEBUG_PERROR("static_membership::init could not open input file");
	return;
    }

    while ((fgets(inbuf, sizeof(inbuf)-1, infile)) != NULL) {
	char *comment;
	char dst[256];
	struct in_addr dstaddr;

	comment = strchr(inbuf, '#');
	if (comment) *comment = '\0';
	/* XXX:  note that this parsing can overflow.  shrug. */

	comment = strchr(inbuf, '\n');
	if (comment) *comment = '\0';
	if ((sscanf(inbuf, "%s", dst)) == 1) {
	    if (!nametoip(dst, &dstaddr)) {
		peerlist.push_back(node(dstaddr));
		DPRINTF(DEBUG_MEMBERSHIP,
			"static_membership::init node 0x%x\n",
			dstaddr.s_addr);
	    } else {
		fprintf(stderr, "Bad peer line: %s\n", inbuf);
	    }
	}
    }
    DPRINTF(DEBUG_MEMBERSHIP, "end of nodes\n");
    fclose(infile);
}

int
static_membership::reload()
{
    init();
    return 0; /* XXX */
}

void
static_membership::dump(FILE *out)
{
    list<node>::const_iterator iter;
    for (iter = peerlist.begin(); iter != peerlist.end(); iter++) {
	printf("%s\n", (*iter).to_string().c_str());
    }
}

int
static_membership::recv(pkt *mypkt, node *, int via_ron)
{
    DPRINTF(DEBUG_MEMBERSHIP|DEBUG_PACKETS,
	    "static_membership::recv got a packet\n");

    /* We don't know what to do with such things.  Just return */
    return 0;
}
