#ifndef _STATIC_ROUTER_H_
#define _STATIC_ROUTER_H_

/*
 * A simple static route router.  This one's really stupid:  It
 * just stores host routes in a hash table, and never deletes
 * them.
 *
 * Routes should be stored in a textfile in "dst" "nexthop"
 * format, like:
 *
 * 10.0.0.1  192.168.1.1
 * ...
 */

#include "forw.h"

namespace RON {

class static_router : public routing_table {
public:
    static_router();		// Gets routes from ENV{"ROUTES"}, routes.txt
    static_router(char *filename); // Gets routes from filename
    virtual ~static_router() { }
    map<unsigned long, unsigned long> table;

    node *lookup(node *dst, pkt *mypkt);
    void configure(Scheduler *s, forw *f);
    int recv(pkt *mypkt, node *mynode, int via_ron);
    int reload();		// Reload routes.
private:
    Scheduler *sched;
    forw *myforw;
    void init();
    char *infilename;
};

}

#endif /* _STATIC_ROUTER_H_ */
