/*
 * Rather boring.  Define the debugging stuff.
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "rondebug.h"

unsigned int debug = 0;

/* We could autogenerate this if we felt like it */

struct debug_def {
    int debug_val;
    char *debug_def;
};

static
struct debug_def debugs[] = {
#include "debug-text.h"
#if 0
    { 0, "No debugging"},
    { 1, "Verbose error reporting"},
    { 2, "Debug initialization"},
    { 4, "Debug requests"},
#endif
    { 0, NULL } /* End of list marker */
};

int set_debug(char *arg)
{
    int i;
    if (!arg || arg[0] == '\0') {
	return -1;
    }

    if (arg[0] == '?' || !strcmp(arg, "list")) {
	fprintf(stderr,
		"Debug values and definitions\n"
		"----------------------------\n");
	for (i = 0;  debugs[i].debug_def != NULL; i++) {
	    fprintf(stderr, "%5d  %s\n", debugs[i].debug_val,
		    debugs[i].debug_def);
	}
	return -1;
    }

    if (isdigit(arg[0])) {
	debug |= atoi(arg);
    }
    return 0;
}

#ifdef _TEST_DEBUG_
int main() {
    if (set_debug("?") != -1) {
	fprintf(stderr, "set_debug(\"?\") returned wrong result code\n");
    }
    exit(0);
}

#endif

/* Packet debugging utilities */

void IPDUMP(struct ip *ip) {
    fprintf(stderr,
	    "IP dump:\n"
	    "  version:  %d\n"
	    "  HL:       %d\n"
	    "  TOS:      %d\n"
	    "  LEN:      %d\n"
	    "  ID:       %d\n"
	    "  Offset:   %d\n"
	    "  Protocol: %d\n"
	    "  Checksum: %d\n"
	    "  TTL:      %d\n"
	    "  Src:      %s\n",
	    ip->ip_v,
	    ip->ip_hl,
	    ip->ip_tos,
	    ntohs(ip->ip_len),
	    ntohs(ip->ip_id),
	    ntohs(ip->ip_off),
	    ip->ip_p,
	    ntohs(ip->ip_sum),
	    ip->ip_ttl,
	    inet_ntoa(ip->ip_src));
    fprintf(stderr,
	    "  Dst:      %s\n",
	    inet_ntoa(ip->ip_dst));
}

void UDPDUMP(myudphdr *udp) {
    fprintf(stderr,
	    "UDP DUMP\n"
	    "   Source port: %d\n"
	    "   Dest port:   %d\n"
	    "   Length:      %d\n"
	    "   Checksum:    %d\n",
	    ntohs(udp->source),
	    ntohs(udp->dest),
	    ntohs(udp->len),
	    ntohs(udp->check));
}

