#ifndef _PDB_CLIENT_H_
#define _PDB_CLIENT_H_

/*
 * The interface to the PDB
 */

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/uio.h>
#include <unistd.h>
#include <string>
#include <list>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <math.h>
#include "fixedpoint.h"
#include "pdb_wire.h"
#include "ronlib.h"
#include "rondebug.h"
#include "forw.h"
#include "ron.h"
#include "node.h"

typedef u_int32_t probe_name_t;

#define PDB_LAT 1
#define PDB_REACH 2

namespace RON {

class pdb_client {
public:
    virtual void configure(Scheduler *s, forw *f) = 0;
    virtual ~pdb_client() {}
    virtual int query(node n, probe_name_t probetype, int summarizer,
		      fixedpoint param, fixedpoint *result) = 0;
    virtual int insert(node n, probe_name_t probetype, fixedpoint value) = 0;
    //virtual int update_fixed(char *classname, fixedpoint value);
    virtual void init() = 0;
};

} /* namespace RON */

#endif /* _PDB_CLIENT_H_ */
