#include "pdb_client.h"

using namespace RON;

class pdbc_callback : public pdb_callable {
public:
    void pdb_callback(int success, char *classname, int summarizer,
		      fixedpoint val) {
	printf("GOT:  Success %d class %s  val: %s\n",
	       success, classname, val.to_string().c_str());
    }
};

int main() {
    pdb_client pdbc;
    pdbc_callback cb;
    int sock;

    sock = pdbc.getsock();
    set_debug("32767");
    
    pdbc.update_fixed("pdbc_test", fixedpoint(1.0));
    pdbc.update_fixed("pdbc_test", fixedpoint(2.0));
    pdbc.update_fixed("pdbc_test", fixedpoint(3.0));
    sleep(1); /* Ensure it gets through */
    pdbc.query_fixed("pdbc_test", SUMMARIZE_EWMA, fixedpoint(0,0),
		     &cb);
    printf("pdbc.query_fixed.  Doing a socket callback\n");
    fflush(stdout);
    pdbc.socket_callback(sock, NULL);
    printf("Socket callback finished, sleeping for 3\n");
    fflush(stdout);
    sleep(3);
    pdbc.clean_queries();
    printf("Trying a multiquery\n");
    fflush(stdout);
    class pdb_onereq reqs[3];
    for (int i = 0; i < 3; i++) {
	reqs[i].classname = "pdbc_test";
	reqs[i].cb = &cb;
    }
    reqs[0].summarizer = SUMMARIZE_EWMA;
    reqs[1].summarizer = SUMMARIZE_MIN;
    reqs[2].summarizer = SUMMARIZE_MAX;
    printf("Sending a multiquery_fixed\n"); fflush(stdout);
    pdbc.multiquery_fixed(3, reqs);
    printf("Doing a socket callback\n");
    fflush(stdout);
    pdbc.socket_callback(sock, NULL);
    sleep(3);
    pdbc.clean_queries();
    exit(0);
    
}
