#include <stdlib.h>
#include "pdb_client.h"
#include "pdb_local_client.h"

using namespace RON;

/* Test program for the linked-in pdb client */

int main(int argc, char* argv[]) {
    pdb_local_client pdbc;
    node n1, n2;

    /* Make up some fake hosts to use */
    n1.node_port = htons(1);
    n1.node_port = htons(2);

    set_debug("32767");

    for (int i = 0; i < 100; i+=2)
	pdbc.insert(n1, 0, fixedpoint(i));

    for (int i = 200; i < 300; i+= 3)
	pdbc.insert(n2, 0, fixedpoint(i));
    
    int rc;
    fixedpoint result;
    
    rc = pdbc.query(n1, 0, SUMMARIZE_EWMA, fixedpoint(0,0), &result);
    if (rc)
	printf("pdbc.query n1 ewma failed\n");
    else
	printf("EWMA on n1:  %s\n", result.to_string().c_str());

    rc = pdbc.query(n1, 0, SUMMARIZE_RECENT, fixedpoint(0,0), &result);
    if (rc)
	printf("pdbc.query n1 recent failed\n");
    else
	printf("Recent on n1:  %s\n", result.to_string().c_str());

    rc = pdbc.query(n2, 0, SUMMARIZE_RECENT, fixedpoint(0,0), &result);
    if (rc)
	printf("pdbc.query n2 recent failed\n");
    else
	printf("Recent on n2:  %s\n", result.to_string().c_str());

    // Error testing
    n2.node_port = htons(5); /* Does  not exist */
    if (rc)
	printf("pdbc.query failed on nonexistent host, as it should\n");
    else
	rc = pdbc.query(n2, 0, SUMMARIZE_RECENT, fixedpoint(0,0), &result);

    exit(0);
}
