pdb_res::pdb_res(char *classname, pdb *user_db) {
	scursor = user_db->get_samples_res(classname);
	dbp = user_db->perf_db;
	at_head_ = 1;
	at_tail_ = 0;
}
    
pdb_res::pdb_res(Dbc *user_search_cursor, Db *user_db) {
	scursor = user_search_cursor;
	dbp = user_db;
	at_head_ = 1;
	at_tail_ = 0;
}

pdb_res::~pdb_res() {
	if (scursor) scursor->close();
}

int pdb_res::succeeded() {
	if (scursor != NULL) return 1;
	return 0;
}
    
/* Type-specific functions:  they all return an item of our type */

int pdb_res::count() {
	int ret;
	db_recno_t count;
	if ((ret = scursor->count(&count, 0))) {
	    dbp->err(ret, "scursor->count in result class");
	    return 0;
	}
	return count;
}

int pdb_res::cur(T *return_value) {
	return db_get(return_value, DB_CURRENT);
}
	
int pdb_res::next(T *return_value) {
	int res;
	
	res = db_get(return_value, DB_NEXT_DUP);

	if (res == DB_NOTFOUND) {
	    at_tail_ = 1;
	} else {
	    at_head_ = 0;
	}
	
	return res;
}

/*
 * Unimplemented access methods;  To implement them,
 * we'll need to change the way we pull data out of
 * the database and start storing it locally, OR
 * repeat our query.  I don't favor the latter;  once
 * the database query is done, we should release everything
 * in the db so other things can start getting work done.
 * Therefore, to implement these, have our initializer
 * store the data from the database in a local list.
 *
 * But for starters, let's see if we can get by
 * without them.  We can certainly implement several
 * of our summarizers using only cur() and next()
 */
	
int pdb_res::head(T *return_value) {
	fprintf(stderr, "pdb_res:  head() method unimplemented\n");
	return -1;
}
    
int pdb_res::prev(T *return_value) {
	fprintf(stderr, "pdb_res:  prev() method unimplemented\n");
	return -1;
}
    
int pdb_res::tail(T *return_value) {
	fprintf(stderr, "pdb_res:  tail() method unimplemented\n");
	return -1;
}

