/**
 *  \file SampleOCDStateInfo.h
 *  \brief OCD state info associated with the sample ocd.
 */
#ifndef SAMPLE_OCD_STATE_INFO
#define SAMPLE_OCD_STATE_INFO 1

#ifndef _WIN32
#	include <sys/types.h>
#	include <sys/socket.h>
#else
#	include "netwrap.h"
#endif

#include "OCD_include.h"

class SampleOCD;



class SampleOCDStateInfo:public OCDStateInfo {
    
    /**
      * The IP address and port number of the remote end point (network byte order).
      * This is the way SampleOCD identifies a tunnel.
      * In i3, the i3 private trigger ids play the role of a unique identifier.
      */
    struct in_addr remoteAddress;
    uint16_t remotePort;

    void refreshState();
    void fakeSetupSuccess();

public:

    SampleOCDStateInfo(OCDHandle myHandle, OCI* oci, SampleOCD *sampleOCD, string endPointName);
    virtual void receivedLegacyDNSReply (uint32_t ipAddress) ;

    friend class SampleOCD;
    friend class SampleOCDContext;
};

#endif
