#ifndef SAMPLE_OCD_DEBUG_FNS_H
#define SAMPLE_OCD_DEBUG_FNS_H 1


#define SAMPLE_OCD_DEBUG


#	ifndef SAMPLE_OCD_PRINT_DEBUG
#		if !defined(_WIN32) || defined(__CYGWIN__)
#			ifdef DEBUG_ENABLED
			/**
   			 * This macro is used to print debugging information. 
			 * The message is printed only if the current debugging level is
			 * greater than that of the level specified in the macro call.
			 */

#				define SAMPLE_OCD_PRINT_DEBUG(debugLevel, msg, ... )  if(debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) { printf("[Line:%d in file:%s] ", __LINE__, __FILE__); printf(msg, ##__VA_ARGS__);}

#			else 

#				define SAMPLE_OCD_PRINT_DEBUG(debugLevel, msg, ... ) 

#			endif //DEBUG_ENABLED

#			define SAMPLE_OCD_PRINT_DEBUG0	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG1	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG2	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG3	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG4	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG5	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG6	SAMPLE_OCD_PRINT_DEBUG
#			define SAMPLE_OCD_PRINT_DEBUG7	SAMPLE_OCD_PRINT_DEBUG

#		else
		// stg: the MS compiler will support variadic macros only from version 7 on. Until then, we will have to live with warnings about too few arguments to this macro
		#define SAMPLE_OCD_PRINT_DEBUG0(debugLevel, msg) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG1(debugLevel, msg, arg1) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG2(debugLevel, msg, arg1, arg2) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG3(debugLevel, msg, arg1, arg2, arg3) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG4(debugLevel, msg, arg1, arg2, arg3, arg4) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG5(debugLevel, msg, arg1, arg2, arg3, arg4, arg5) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG6(debugLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6);fflush(sampleOCDDebugFD);}
		#define SAMPLE_OCD_PRINT_DEBUG7(debugLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7) if (debugLevel <= SAMPLE_OCD_CURRENT_DEBUG_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7);fflush(sampleOCDDebugFD);}
		//#define SAMPLE_OCD_PRINT_DEBUG(debugLevel, msg)
#endif
#endif  //SAMPLE_OCD_PRINT_DEBUG

/**
  * This macro is used to print messages irrespective of debug level.
  * These are messages are not for debugging, but for giving information
  * to the user.
  */
#	ifndef SAMPLE_OCD_PRINT_INFO
#		if !defined(_WIN32) || defined(__CYGWIN__)
#			define SAMPLE_OCD_PRINT_INFO(infoLevel, msg, ...) if(infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) printf(msg, ##__VA_ARGS__)

#			define SAMPLE_OCD_PRINT_INFO0	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO1	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO2	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO3	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO4	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO5	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO6	SAMPLE_OCD_PRINT_INFO
#			define SAMPLE_OCD_PRINT_INFO7	SAMPLE_OCD_PRINT_INFO

#		else
			// stg: the MS compiler will support variadic macros only from version 7 on. Until then, we will have to live with warnings about too few arguments to this macro
//#			define SAMPLE_OCD_PRINT_INFO(infoLevel, msg)
#			define SAMPLE_OCD_PRINT_INFO0(infoLevel, msg) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO1(infoLevel, msg, arg1) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO2(infoLevel, msg, arg1, arg2) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO3(infoLevel, msg, arg1, arg2, arg3) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO4(infoLevel, msg, arg1, arg2, arg3, arg4) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO5(infoLevel, msg, arg1, arg2, arg3, arg4, arg5) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO6(infoLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6);fflush(sampleOCDDebugFD);}
#			define SAMPLE_OCD_PRINT_INFO7(infoLevel, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7) if (infoLevel <= SAMPLE_OCD_CURRENT_INFO_LEVEL) {fprintf (sampleOCDDebugFD, msg, arg1, arg2, arg3, arg4, arg5, arg6, arg7);fflush(sampleOCDDebugFD);}
#		endif
#endif //SAMPLE_OCD_PRINT_INFO


#endif
